<?php
	
define('MAXLINELEN', 512);

// no cache for browser
header('Cache-Control: no-cache, must-revalidate');
// security check
require_once 'secureLogin.php';
include_once "sysfunc.php";
include_once 'cmvar.php';	 // for $lang
include_once("..\\authserv\\common_functions.php");

// This function is used to convert an integer to a hexadecimal number
// and organize it to mac format
function fs_create_random_password($len)
{
    $pass = '';
    $lchar = 0;
    $char = 0;
    for($i = 0; $i < $len; $i++) {
        while($char == $lchar) {
            $char = rand(97, 122);
        }
        $pass .= chr($char);
        $lchar = $char;
    }
    return $pass;
}

// 20070221 begin spun - added $slip_user argument to pass out the user info	
// function fs_create_bulk_user($username, $password1, $password2, $plan)
function fs_create_bulk_user($username, $password1, $password2, $plan, &$slip_user)
{
    // return status (integer)
    // 0 - no problem, id successfully created
    // 1 - username cannot be empty
    // 2 - duplicated user id found in user database
    // 3 - password cannot be empty
    // 4 - 2 passwords did not match

    $function_status=99;
    $create_id='yes';

    if ($username =='') {
        $function_status =1;
        $create_id='no';
    } else {
        $q="SELECT count(*) as no FROM ".fs_usr_table()." where name='$username'";
        $result=db_query($q);
        $no = odbc_result($result, 'no');

        if (($no > 0) && ($username !='')) {
            $function_status =2;   //duplicated user id
            $create_id='no';
        } else if (($password1=='') && ($password2=='') && ($username !='') && ($create_id='yes')) {
            $function_status =3; //password not empty
            $create_id='no';
        } else if ((strcmp ($password1 , $password2) <> 0 ) && ($create_id='yes')) {
            $function_status =4; //passwords did not match
            $create_id='no';
        }

        if ($create_id == 'yes') {
            // create COM object
            $settingobj = new COM('FSCONFIG.Cfgmgr') or die('settingok.php FSCONFIG.Cfgmgr Object cannot be created!');

            $pwd_offload=$settingobj->getKey('pwd_offload', 'gateway');

            if($pwd_offload=='on'||$pwd_offload=='ON') {
                $encrypt_path=$settingobj->getKey('encrypt_path', 'gateway');
            } else {
                $fs_path = $settingobj->getFsPath();
                $encrypt_path = $fs_path."dispatcher\\encrypt_pwd.exe";
            }
            $cmd = "\"".$encrypt_path."\" ".$password1;
            //$pwd = $settingobj->runCommand($cmd);
			$sys = new sysfunc();
	        $pwd = $sys->runCommand($cmd);
	        $sys = null;
            
            $plan_table=$settingobj->getKey('Datasource_Plans_Tablename', 'gateway');
            //free COM object
            //$settingobj->Release();
            $settingobj=null;

            $q_plan = "SELECT * FROM ".$plan_table." WHERE PNAME = '".$plan."' ;";
            $result_plan = db_query($q_plan);

	    // 20080425 - Bug fix (add quota sharing part)
            $timeleft = odbc_result($result_plan, 'TIMELEFT');
            $btul = odbc_result($result_plan, 'BTUL');
            $btdl = odbc_result($result_plan, 'BTDL');
            $bwquota = odbc_result($result_plan, 'BWQUOTA');
            $bwcount = odbc_result($result_plan, 'BWCOUNT');
            $bwquotaUL = odbc_result($result_plan, 'BWQUOTAUL');
            $bwcountUL = odbc_result($result_plan, 'BWCOUNTUL');
            $bwquotaSha = odbc_result($result_plan, 'BWQUOTASHA');
            $bwcountSha = odbc_result($result_plan, 'BWCOUNTSHA');
            $sdate = odbc_result($result_plan, 'SDATE');
            $edate = odbc_result($result_plan, 'EDATE');
            $logins = odbc_result($result_plan, 'LOGINS');
            $mins = odbc_result($result_plan, 'EMINUTES');
            $startmod = odbc_result($result_plan, 'STARTMOD');
            $plan_status = odbc_result($result_plan, 'STATUS');
            $bwrmethod = odbc_result($result_plan, 'BWRMETHOD');
            $bwrperiod = odbc_result($result_plan, 'BWRPERIOD');
            $bwrdate = odbc_result($result_plan, 'BWRDATE');
            $printQutoa = round(odbc_result($result_plan, 'pagenum'));
            $acl = odbc_result($result_plan, 'acl');
            $reqsignup = odbc_result($result_plan, 'reqsignup');

			// spun : 20070303 previously missed fields
			$mac_map = odbc_result($result_plan, 'macmap');
			$ip_map = odbc_result($result_plan, 'ipmap');
			//recur_option
			$recur_option = odbc_result($result_plan, 'roption');
			$recur_sdate = odbc_result($result_plan, 'rsdate');			
			$recur_edate = odbc_result($result_plan, 'redate');			
			$week_sch = odbc_result($result_plan, 'weeksch');
			$auto_delete = odbc_result($result_plan, 'auto_del');
			
            $q="Insert into ".fs_usr_table()." (name, pwd, ";
            $qend = ") values ('$username', '$pwd', ";

	    // 20080425 - Bug fix (add quota sharing part)
	    // 20070221 begin spun - printing user info in a slip 		
            if ($timeleft != '') {
                $q .= 'timeleft, ';
                $qend .= "$timeleft, ";				
				$slip_user['cb_acc1']= true;
				$slip_user['add_timeleft']=$timeleft ;
			}
            if ($btul != '') {
                $q .= 'btul, ';
                $qend .= "$btul, ";				
				$slip_user['bt_ul_limit'] = $btul;
            }
            if ($btdl != '') {
                $q .= 'btdl, ';
                $qend .= "$btdl, ";
				$slip_user['bt_dl_limit'] = $btdl;		
            }
            if ($bwquota != '') {
                $q .= 'bwquota, ';
                $qend .= "$bwquota, ";
				$slip_user['bwquota'] = $bwquota;
            }
            if ($bwcount != '') {
                $q .= 'bwcount, ';
                $qend .= "$bwcount, ";
				$slip_user['bwcount'] = $bwcount;
            }
            if ($bwquotaUL != '') {
                $q .= 'bwquotaUL, ';
                $qend .= "$bwquotaUL, ";
				$slip_user['bwquotaUL'] = $bwquotaUL;
            }
            if ($bwcountUL != '') {
                $q .= 'bwcountUL, ';
                $qend .= "$bwcountUL, ";
				$slip_user['bwcountUL'] = $bwcountUL;
            }
            if ($bwquotaSha != '') {
                $q .= 'bwquotaSha, ';
                $qend .= "$bwquotaSha, ";
		$slip_user['bwquotaSha'] = $bwquotaSha;
            }
            if ($bwcountSha != '') {
                $q .= 'bwcountSha, ';
                $qend .= "$bwcountSha, ";
		$slip_user['bwcountSha'] = $bwcountSha;
            }
            if ($plan_status != '') {
                $q .= 'status, ';
                $qend .= "$plan_status, "; 
				//spun: original editUser.php does not print if the a/c is disabled or not, no need
            }
            if ($edate != '') {
                $q .= 'edate, ';
                $qend .= "'$edate', ";
				
				$slip_user['cb_acc3'] = true; 
				$expiryDatetime = array();
				$expiryDatetime = datetime_from_mysql2($edate);	// from  common_functions.php		
				$slip_user['add_exp_date']= $expiryDatetime[0]; 
				$slip_user['add_exp_time']= $expiryDatetime[1];
            }
            if ($sdate != '') {
                $q .= 'sdate, ';
                $qend .= "'$sdate', ";
								
				// $startDate[$act_date, $act_time] in setcfg_plan.php, 
				$slip_user['bt_acc'] = 2;
				$activeDatetime = array();
				$activeDatetime = datetime_from_mysql2($sdate);
				$slip_user['add_act_date']= $activeDatetime[0]; 
				$slip_user['add_act_time']= $activeDatetime[1];            
            }else if ($sdate == '' && $startmod == 0){ // 0 means Account is active now (must fill in sdate field)
	            // fill in sdate field
	            $startDate=date("D M d H:i:s Y");
	            $q .= 'sdate, ';
                $qend .="'" . $startDate . "', ";
            }
            if ($logins != '') { 
                $q .= 'logins, ';
                $qend .= "$logins, ";
				
				// suspend a/c after x logins
				$slip_user['cb_acc2']= true;
				$slip_user['add_login']= $logins;
            }
            if ($mins != '') {
                $q .= 'eminutes, ';
                $qend .= "$mins, ";
				
				// suspend a/c after x mins
				$slip_user['cb_acc4']= true;
				$timeLeft = "";
				switch (true){
					case ($mins/60/24 >=1): $timeLeft= $mins/60/24 ." day"; break;
					case ($mins/60>=1): $timeLeft= $mins/60 ." hour"; break;
					default: $timeLeft = $mins ." min"; break;
				}
				$slip_user['add_days']= $timeLeft;
            }
            if ($startmod != '') {
                $q .= 'STARTMOD, ';
                $qend .= "$startmod, ";
				// when a/c is active, $startmod is either of values [0, 1, 2]
				$slip_user['bt_acc'] = $startmod;
            }
            if ($bwrmethod != '') {
                $q .= 'bwrmethod, ';
                $qend .= "'$bwrmethod', ";
				//spun: original editUser.php does not print when data transfer quota reset
            }
            if ($bwrperiod != '') {
                $q .= 'bwrperiod, ';
                $qend .= "$bwrperiod, ";
				//spun: original editUser.php does not print when data transfer quota reset
            }
            if ($bwrdate != '') {
                $q .= 'bwrdate, ';
                $qend .= "$bwrdate, ";
				//spun: original editUser.php does not print when data transfer quota reset
            }
            $q .= 'pagenum, ';			
            $qend .= "$printQutoa, ";
			
			$slip_user['printQuota'] = $printQutoa; 
			
            $q .= 'acl, ';
            //access control list
            if ($acl=='Y') {
                $qend .= "'Y', ";
            } else {
                $qend .= 'NULL, ';
            }
            $q .= 'reqsignup, ';
            //request signup
            if ($reqsignup=='Y') {
                $qend .= "'Y', ";
            } else {
                $qend .= 'NULL, ';
            }

			// spun : 20070303 previously missed fields
			if ($mac_map != '') {
				$q .= 'macmap, ';
                $qend .= "$mac_map, ";
				$slip_user['macmap'] = $mac_map;
			}
			if ($ip_map != '') {
				$q .= 'ipmap, ';
                $qend .= "$ip_map, ";
				$slip_user['ipmap'] = $ip_map;
			}			
			if ($recur_option != '' && $recur_option != 0){	
				$q .= 'roption, rsdate, redate, weeksch, ';				
				
				if ($recur_sdate != ''){
					$recur_sdate_str = $recur_sdate;
				}else{
					$recur_sdate_str = "NULL";
				}
				
				if ($recur_edate != ''){
					$recur_edate_str = $recur_edate;
				}else{
					$recur_edate_str = "NULL";
				}
				
				$qend .= "$recur_option, '$recur_sdate_str', '$recur_edate_str', $week_sch, ";			
				
				$stime = $recur_sdate;
	        	$etime = $recur_edate;
				$slip_user['recurring1'] = " ($stime - $etime) ";			
				
				if (($week_sch & 2) != 0) $valid_days[] = get_cm_var('setcfg_mon');
				if (($week_sch & 4) != 0) $valid_days[] = get_cm_var('setcfg_tue');
				if (($week_sch & 8) != 0) $valid_days[] = get_cm_var('setcfg_wed');
				if (($week_sch & 16) != 0) $valid_days[] = get_cm_var('setcfg_thu');
				if (($week_sch & 32) != 0) $valid_days[] = get_cm_var('setcfg_fri');
				if (($week_sch & 64) != 0) $valid_days[] = get_cm_var('setcfg_sat');
				if (($week_sch & 1) != 0) $valid_days[] = get_cm_var('setcfg_sun');						
				if (isset($valid_days)) {					
					$days_str  = join($valid_days, ", ");
					$slip_user['days_str'] = $days_str;
				} else{
					$slip_user['days_str'] = "Nil";
				}
			}
			if ($auto_delete != '') {
                $q .= 'auto_del, ';
                $qend .= "$auto_delete, "; 
				// no need for slip printing
            }
			
            $q=substr($q, 0, strlen($q)-2);
            $qend=substr($qend, 0, strlen($qend)-2);
            $q .= "$qend)";
            $result_update=db_query($q);
            $function_status=0;
        }
    }
    return $function_status;
}

// create COM object
$settingobj = new COM('FSCONFIG.Cfgmgr') or die('settingok.php FSCONFIG.Cfgmgr Object cannot be created!');
$version=$settingobj->getKey('version', 'version');
//$settingobj->Release();
$settingobj=null;


if(isset($start) && $start=='true') { //start button is clicked
    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('settingok.php FSCONFIG.Cfgmgr Object cannot be created!');
    $rsult = $settingobj->stratService();
    //$settingobj->Release();
    $settingobj=null;
} 
else if(isset($stop) && $stop=='true') { //stop button is clicked
    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('settingok.php FSCONFIG.Cfgmgr Object cannot be created!');
    $rsult = $settingobj->stopService();
    //$settingobj->Release();
    $settingobj=null;
}

else if(isset($save_d) && $save_d=='true') 
{
    //dispatcher service settings
    $cat='d';
	$settingobj = new COM('FSCONFIG.Cfgmgr') or die('settingok.php FSCONFIG.Cfgmgr Object cannot be created!');
	
    /*//****************************************************************************************************
    // Proxy ARP
    //****************************************************************************************************
    require_once 'display_list.php';

    if (isset($ser_display_proxy)&&($ser_display_proxy!=='')) {
        $display_proxy = unserialize($ser_display_proxy);
    }
    if (isset($ser_add_proxy)&&($ser_add_proxy!=='')) {
        $add_proxy = unserialize($ser_add_proxy);
    }

    $str=''; $j=0; $n=0; $m=0;
    $i=0;
    
    while ($i < $display_proxy->num_sites) {
        if($display_proxy->site_list[$i]->span{0}!='#') {
            $rsult = $settingobj->setKey($display_proxy->site_list[$i]->span, "ip_addr$n", 'proxyARP');
            $n++;
        }
        $i++;
    }

    $j=$n;
    $i=0;
    while ($i < $add_proxy->num_sites) {
        if (($add_proxy->site_list[$i]->span!=';')&&($add_proxy->site_list[$i]->span{0}!='#')) { 
            $rsult = $settingobj->setKey($add_proxy->site_list[$i]->span, 'ip_addr'.($m+$j), 'proxyARP');
            $m++;
        }
        $i++;
    }

    $proxy_num = $m+$j;
    $rsult = $settingobj->setKey($proxy_num, 'ip_num', 'proxyARP');

    // unset all variables
    $ser_display_proxy=NULL;
    $ser_add_proxy=NULL;

    // clear all entries when disabled
    if( isset($parp) && strcmp($parp, 'off')==0 ) {
        $num = $settingobj->getKey('ip_num', 'proxyARP');
        $rsult = $settingobj->setKey('', 'ip_num', 'proxyARP');
        for( $i=0; $i<$num; $i++ )
            $rsult = $settingobj->setKey('0', 'ip_addr'.$i, 'proxyARP');
    }
*/
    //****************************************************************************************************
    // QoS
    //****************************************************************************************************

    require_once 'display_list.php';
    if (isset($ser_display_qos)&&($ser_display_qos!=='')) {
        $display_qos = unserialize($ser_display_qos);
    }
    if (isset($ser_add_qos)&&($ser_add_qos!=='')) {
        $add_qos = unserialize($ser_add_qos);
    }

    $str=''; $j=0; $n=0; $m=0;
    $i=0;
    while ($i < $display_qos->num_sites) {
        if($display_qos->site_list[$i]->span{0}!='#'){
            $skype_proto = explode(' ',$display_qos->site_list[$i]->span);
            if(strcmp(strtoupper($skype_proto[0]),'SKYPE')==0) {
                $skype_proto[0] = '2';
                $display_qos->site_list[$i]->span = $skype_proto[0] . ' ' . $skype_proto[1] . ' ' . $skype_proto[2] . ' ' . $skype_proto[3] . ' ' . $skype_proto[4] ;
            }
            $rsult = $settingobj->setKey($display_qos->site_list[$i]->span, 'qos_'.$n, 'QOS');
            $n++;
        }
        $i++;
    }
    $j=$n;
    $i=0;
    while ($i<$add_qos->num_sites) {
        if($add_qos->site_list[$i]->checked=='false' || $add_qos->site_list[$i]->span{0}!='#') {
            if ($add_qos->site_list[$i]->span{0}=='#') //replace # 
                $add_qos->site_list[$i]->span = substr($add_qos->site_list[$i]->span, 1, strlen($add_qos->site_list[$i]->span));

            $skype_proto = explode(' ',$add_qos->site_list[$i]->span);
            if(strcmp(strtoupper($skype_proto[0]),'SKYPE')==0) {
                $skype_proto[0] = '2';
                $add_qos->site_list[$i]->span = $skype_proto[0] . ' ' . $skype_proto[1] . ' ' . $skype_proto[2] . ' ' . $skype_proto[3] . ' ' . $skype_proto[4] ;
            }

            $rsult = $settingobj->setKey($add_qos->site_list[$i]->span, 'qos_'.($m+$j), 'QOS');
            $m++;
        }
        $i++;
    }

    $qos_num = $m+$j;

    if(isset($qos_num)) {
        if($qos_num >= 10)  
            $qos_num = 9;

        $rsult = $settingobj->setKey($qos_num, 'qos_num', 'QOS');
        if ($qos_num == 0) {
            $rsult = $settingobj->setKey('', 'dl', 'QOS');
            $rsult = $settingobj->setKey('', 'ul', 'QOS');
        }
    }
    // unset all variables
    $ser_display_qos=NULL;
    $ser_add_qos=NULL;

    // clear all entries when disabled
    if (isset($qos) && strcmp($qos,'off')==0) {
        $rsult = $settingobj->setKey('', 'dl', 'QOS');
        $rsult = $settingobj->setKey('', 'ul', 'QOS');
        $num = $settingobj->getKey('qos_num', 'QOS');
        $rsult = $settingobj->setKey('', 'qos_num', 'QOS');

        for ($i=0;$i<$num;$i++)
            $rsult = $settingobj->setKey('0', 'qos_'.$i, 'QOS');

    } else if(isset($qos) && strcmp($qos,'on')==0) {
        $result = $settingobj->setKey($qos_dl, 'dl', 'QOS');
        $result = $settingobj->setKey($qos_ul, 'ul', 'QOS');
    }
    //****************************************************************************************************
    // End QoS
    //****************************************************************************************************

    function addr_space($gateway_IP0, $subnet_mask0)
    {
        if (!function_exists('mask_field'))  {
            function mask_field($dec_no, $mask)
            {
                // precondition: range of $dec_no 0 to 255, range of $mask {255,254,252,248,240,224,192,128,0}

                $i=8; $m=$mask;
                while (($i>0)&&($m%2==0)) {
                    $m=(int)$m/2;
                    $i--;
                }    
                $bitStr=str_pad(decbin($dec_no),8,'0',STR_PAD_LEFT);
                $bitStr=str_pad(substr($bitStr,0,$i),8,'0',STR_PAD_RIGHT);
                return (bindec($bitStr));
            }
        }

        $IP_fields=split("\.", $gateway_IP0, 4);
        $IP_masks=split("\.", $subnet_mask0, 4);

        $private_IP0=mask_field($IP_fields[0],$IP_masks[0]);
        $i=1;
        while ($i<4) {
            $private_IP0=$private_IP0.".".mask_field($IP_fields[$i],$IP_masks[$i]);
            $i++;
        }
        return($private_IP0);
    }

    $gateway_IP=$gateway_IP0.".".$gateway_IP1.".".$gateway_IP2.".".$gateway_IP3;
    $subnet_mask=$subnet_mask0.".".$subnet_mask1.".".$subnet_mask2.".".$subnet_mask3;

    if(isset($port))
        $rsult=$settingobj->setKey($port, 'port', 'gateway');

    if(isset($idle_timeout))
        $rsult = $settingobj->setKey($idle_timeout, 'idle_timeout', 'gateway');

    if(isset($sessionlimit))
        $rsult = $settingobj->setKey($sessionlimit, 'sessionlimit', 'gateway');
        
    if(isset($max_conc_user))
        $rsult = $settingobj->setKey($max_conc_user, 'max_conc_user', 'gateway');

    if(isset($gateway_IP))
        $rsult = $settingobj->setKey($gateway_IP, 'gateway_IP', 'gateway');
    $rsult = $settingobj->setKey($gateway_IP, 'auth_IP', 'gateway');

    if(isset($gateway_IP)&&isset($subnet_mask)) {
        $private_IP=addr_space($gateway_IP,$subnet_mask);
        $rsult = $settingobj->setKey($private_IP, 'private_IP', 'gateway');
    }
    if(isset($subnet_mask))
        $rsult = $settingobj->setKey($subnet_mask, 'subnet_mask', 'gateway');
/*
    if(isset($nat))
        $rsult = $settingobj->setKey($nat, 'nat', 'gateway');
*/
    if(isset($netbios))
        $rsult = $settingobj->setKey($netbios, 'netbios', 'gateway');
    
    /*
    // [sphl] 20070216 moved to save_key
    if(isset($dns_suffix))
        $rsult = $settingobj->setKey($dns_suffix, 'dns_suffix', 'gateway');
    */

    if(isset($batch_filePath))
        $rsult = $settingobj->setKey(stripslashes($batch_filePath), 'batch_filePath', 'gateway');


    $bt_ul_limit=null;
    $bt_dl_limit=null;

    // obtain low, medium or high BT value from config.ini

    $outval = $settingobj->getKey('bt_low', 'bw_throttle');

    if($outval!='')       
        $low=$outval;

    $outval = $settingobj->getKey('bt_medium', 'bw_throttle');

    if($outval!='')       
        $medium=$outval;

    $outval = $settingobj->getKey('bt_high', 'bw_throttle');

    if($outval!='')       
        $high=$outval;

    switch($bt_mode)
    {
    case 0:  $bt_ul_limit=0;
        $bt_dl_limit=0;
        break;

    case 1:  $bt_ul_limit=$low;
        $bt_dl_limit=$low;
        break;

    case 2:  $bt_ul_limit=$medium;
        $bt_dl_limit=$medium;
        break;

    case 3:  $bt_ul_limit=$high;
        $bt_dl_limit=$high;
        break;

    case 4:  if (!isset($bt_num) || $bt_num == '')
        $bt_num=0;
        if (!isset($bt_num_down) || $bt_num_down == '')
            $bt_num_down=0;
        $bt_ul_limit=$bt_num;
        $bt_dl_limit=$bt_num_down;
        break;

    default:
        // set to something high so that it won't affect the Internet access
        echo 'undefined global bandwidth throttling mode';
        $bt_ul_limit=9999;
        $bt_dl_limit=9999;
        break;
    }

    $rsult_ul = $settingobj->setKey($bt_ul_limit, 'bt_ul_limit', 'bw_throttle');
    $rsult_dl = $settingobj->setKey($bt_dl_limit, 'bt_dl_limit', 'bw_throttle');

    if ($bt_ul_limit==0 && $bt_dl_limit==0)
        $rsult = $settingobj->setKey(0, 'bt_mode', 'bw_throttle'); //guard against setting BOTH custom value blank
    else
        $rsult = $settingobj->setKey($bt_mode, 'bt_mode', 'bw_throttle');

    switch($abw_rm)
    {
    case 0:
        $settingobj->setKey('', 'bwresetmethod', 'bwreset');
        $settingobj->setKey('', 'bwresetperiod', 'bwreset');
        //$settingobj->setKey('', 'lastresetbw', 'bwreset');
        break;
    case 1:
    		// prevent not in range 
        $settingobj->setKey('month', 'bwresetmethod', 'bwreset');
        if(!is_numeric($abw_rp_1)||$abw_rp_1<1)
            $abw_rp_1 = 1;
        $settingobj->setKey( $abw_rp_1, 'bwresetperiod', 'bwreset');

        if(!is_numeric($abw_rdate)||$abw_rdate>31)
            $abw_rdate = 1;

        // prevent not in range 
        if ($abw_rdate>0)
        	$settingobj->setKey($abw_rdate, 'bwresetdate', 'bwreset');
        else 
         	$settingobj->setKey(1, 'bwresetdate', 'bwreset');
        
        //Set lastrbw  	
        $currTime = '';
        
        $rp_abw_sdate=$settingobj->getKey('sdate', 'bwreset');
        if ($rp_abw_sdate == '' || $rp_abw_sdate == null){
	        $rp_abw_sdate = date("D M j G:i:s Y");
	        $settingobj->setKey($rp_abw_sdate, 'sdate', 'bwreset');
        }	    		
				$temp = datetime_from_mysql($rp_abw_sdate);
				$currTime = mktime_from_datetime($temp[0],$temp[1]);
        
        if ($abw_lastrbw_date !=null && $abw_lastrbw_time != null ){
        	$currTime = mktime_from_datetime($abw_lastrbw_date,$abw_lastrbw_time);
      	}
	    		
				$settingobj->setKey($currTime, 'lastresetbw', 'bwreset');
        
        break;
    case 2:
        $settingobj->setKey('day', 'bwresetmethod', 'bwreset');
        // prevent not in range 
        if(!is_numeric($abw_rp_2)||$abw_rp_2<1)
            $abw_rp_2 = 1;
        $settingobj->setKey($abw_rp_2, 'bwresetperiod', 'bwreset');
        
        //Set lastrbw  	
        $currTime = '';
        
        $rp_abw_sdate=$settingobj->getKey('sdate', 'bwreset');
        if ($rp_abw_sdate == '' || $rp_abw_sdate == null){
	        $rp_abw_sdate = date("D M j G:i:s Y");
	        $settingobj->setKey($rp_abw_sdate, 'sdate', 'bwreset');
        }	    		
				$temp = datetime_from_mysql($rp_abw_sdate);
				$currTime = mktime_from_datetime($temp[0],$temp[1]);
        
        if ($abw_lastrbw_date !=null && $abw_lastrbw_time != null ){
        	$currTime = mktime_from_datetime($abw_lastrbw_date,$abw_lastrbw_time);
      	}
	    		
				$settingobj->setKey($currTime, 'lastresetbw', 'bwreset');
      		
        break;
    }

    /*******************************************************************************
    **  SMTP
    *******************************************************************************/
    if(isset($smtp_on_selection)&&$smtp_on_selection=='smtp_on' && isset($IspSmtpDomain) &&$IspSmtpDomain!='' ) { // on smtp and use isp smtp
        $settingobj->setKey('true', 'smtp', 'fssmtp');
        $settingobj->setKey($IspSmtpDomain, 'IspSmtpDomain', 'fssmtp');
        
        if (isset($rcptMax) || $rcptMax=='')
            $settingobj->setKey($rcptMax, 'rcptMax', 'fssmtp');
        if (isset($mailsize) || $mailsize=='')
            $settingobj->setKey($mailsize, 'mailsize', 'fssmtp');
        if (isset($execTime) || $execTime=='')
            $settingobj->setKey($execTime, 'execTime', 'fssmtp');
        if (isset($SmtpPort) || $SmtpPort=='')
            $settingobj->setKey($SmtpPort, 'SmtpPort', 'fssmtp');

            if(isset($IspSmtpAuthLogin)&& $IspSmtpAuthLogin=='true' &&
            	 isset($IspSmtpUserName) && $IspSmtpUserName != NULL &&
            	 isset($IspSmtpPassword)  && $IspSmtpPassword != NULL 
            ) {
        		$settingobj->setKey('true', 'IspSmtpAuthLogin', 'fssmtp');
            	$settingobj->setKey($IspSmtpUserName, 'IspSmtpUserName', 'fssmtp');
            	$settingobj->setKey($IspSmtpPassword, 'IspSmtpPassword', 'fssmtp');
      		 }else {
	      		$settingobj->setKey('false', 'IspSmtpAuthLogin', 'fssmtp');
	      		$settingobj->setKey('', 'IspSmtpUserName', 'fssmtp');
            	$settingobj->setKey('', 'IspSmtpPassword', 'fssmtp');
      			}

    } else {
        $settingobj->setKey('false', 'smtp', 'fssmtp');
		$settingobj->setKey('', 'IspSmtpDomain', 'fssmtp');
		$settingobj->setKey('false', 'IspSmtpAuthLogin', 'fssmtp');
       	$settingobj->setKey('', 'IspSmtpUserName', 'fssmtp');
       	$settingobj->setKey('', 'IspSmtpPassword', 'fssmtp');
       	//$settingobj->setKey('', 'SmtpPort', 'fssmtp');
    }
    /*******************************************************************************
    **  END - SMTP
    *******************************************************************************/

    //****************************************************************************************************
    // Global data transfer setting
    //****************************************************************************************************
    if( isset($bw_setting_dl) && $bw_setting_dl == 0 )
        $settingobj->setKey('0', 'bwcount_dl', 'DataTransfer');
    else {
        if( isset($bwdl_quota_checkbox) && isset($bwdl_quota) ) {
            $settingobj->setKey('2', 'bwcount_dl', 'DataTransfer');
            $settingobj->setKey( $bwdl_quota, 'bwquota_dl', 'DataTransfer');
        } else
            $settingobj->setKey('1', 'bwcount_dl', 'DataTransfer');
    }

    if( isset($bw_setting_ul) && $bw_setting_ul == 0 )
        $settingobj->setKey('0', 'bwcount_ul', 'DataTransfer');
    else {
        if( isset($bwul_quota_checkbox) && isset($bwul_quota) ) {
            $settingobj->setKey('2', 'bwcount_ul', 'DataTransfer');
            $settingobj->setKey($bwul_quota, 'bwquota_ul', 'DataTransfer');
        }
        else
            $settingobj->setKey('1', 'bwcount_ul', 'DataTransfer');
    }
    //****************************************************************************************************
    // End - Global data transfer setting
    //****************************************************************************************************

    $message='Dispatcher setting is successfully saved. All changes will take effect when you start FirstSpot next time.';
    $saved='true';
    $errorlog='';
    //free COM object
    //$settingobj->Release();
    $settingobj=null;
} //end dispatcher service settings

else if(isset($save_nat) && $save_nat=='true') 
{
    //NAT service settings
    $cat='nat';

    //****************************************************************************************************
    // Proxy ARP
    //****************************************************************************************************
    require_once 'display_list.php';
	$settingobj = new COM('FSCONFIG.Cfgmgr') or die('settingok.php FSCONFIG.Cfgmgr Object cannot be created!');
    
    if (isset($ser_display_proxy)&&($ser_display_proxy!=='')) {
        $display_proxy = unserialize($ser_display_proxy);
    }
    if (isset($ser_add_proxy)&&($ser_add_proxy!=='')) {
        $add_proxy = unserialize($ser_add_proxy);
    }

    $str=''; $j=0; $n=0; $m=0;
    $i=0;   
    while ($i < $display_proxy->num_sites) {
        if($display_proxy->site_list[$i]->span{0}!='#') {
            $rsult = $settingobj->setKey($display_proxy->site_list[$i]->span, "ip_addr$n", 'proxyARP');
            $n++;
        }
        $i++;
    }

    $j=$n;
    $i=0;
    while ($i < $add_proxy->num_sites) {
        if (($add_proxy->site_list[$i]->span!=';')&&($add_proxy->site_list[$i]->span{0}!='#')) { 
            $rsult = $settingobj->setKey($add_proxy->site_list[$i]->span, 'ip_addr'.($m+$j), 'proxyARP');
            $m++;
        }
        $i++;
    }

    $proxy_num = $m+$j;
    $rsult = $settingobj->setKey($proxy_num, 'ip_num', 'proxyARP');

    // unset all variables
    $ser_display_proxy=NULL;
    $ser_add_proxy=NULL;

    // clear all entries when disabled
    if( isset($parp) && strcmp($parp, 'off')==0 ) {
        $num = $settingobj->getKey('ip_num', 'proxyARP');
        $rsult = $settingobj->setKey('', 'ip_num', 'proxyARP');
        for( $i=0; $i<$num; $i++ )
            $rsult = $settingobj->setKey('0', 'ip_addr'.$i, 'proxyARP');
    }
	
    if (isset($ser_display_nat_P)&&($ser_display_nat_P!=='')) {
        $display_nat_P = unserialize($ser_display_nat_P);
    }
	if (isset($ser_display_nat_R)&&($ser_display_nat_R!=='')) {
        $display_nat_R = unserialize($ser_display_nat_R);
    }
    if (isset($ser_add_nat_P)&&($ser_add_nat_P!=='')) {
        $add_nat_P = unserialize($ser_add_nat_P);
    }
    if (isset($ser_add_nat_R)&&($ser_add_nat_R!=='')) {
        $add_nat_R = unserialize($ser_add_nat_R);
    }
	
	$nat_IP_S=$nat_IP_S0.".".$nat_IP_S1.".".$nat_IP_S2.".".$nat_IP_S3;
	$nat_IP_E=$nat_IP_E0.".".$nat_IP_E1.".".$nat_IP_E2.".".$nat_IP_E3;
    $subnet_mask=$subnet_mask0.".".$subnet_mask1.".".$subnet_mask2.".".$subnet_mask3;
    
    if(isset($nat_IP_S))
        $rsult = $settingobj->setKey($nat_IP_S, 'NAT_AddrR_ipS', 'NAT');
    if(isset($nat_IP_E))
        $rsult = $settingobj->setKey($nat_IP_E, 'NAT_AddrR_ipE', 'NAT');
    if(isset($subnet_mask))
        $rsult = $settingobj->setKey($subnet_mask, 'NAT_AddrR_SubNet', 'NAT');

    $str=''; $j=0; $n=0; $m=0;
    $i=0;
    
    while ($i < $display_nat_P->num_sites) {
        if($display_nat_P->site_list[$i]->span{0}!='#') {
            $rsult = $settingobj->setKey($display_nat_P->site_list[$i]->span, "Mapping_Private_IP_$n", 'NAT');
            $rsult = $settingobj->setKey($display_nat_R->site_list[$i]->span, "Mapping_Real_IP_$n", 'NAT');
            $n++;
        }
        $i++;
    }

    $j=$n;
    $i=0;
    while ($i < $add_nat_P->num_sites) {
        if (($add_nat_P->site_list[$i]->span!=';')&&($add_nat_P->site_list[$i]->span{0}!='#')) { 
            $rsult = $settingobj->setKey($add_nat_P->site_list[$i]->span, 'Mapping_Private_IP_'.($m+$j), 'NAT');
            $rsult = $settingobj->setKey($add_nat_R->site_list[$i]->span, 'Mapping_Real_IP_'.($m+$j), 'NAT');
            $m++;
        }
        $i++;
    }

    $nat_num = $m+$j;
    $rsult = $settingobj->setKey($nat_num, 'NAT_AddrM_Count', 'NAT');
	$rsult = $settingobj->setKey($nat, 'Enable', 'NAT');

    // unset all variables
    $ser_display_nat_P=NULL;
    $ser_display_nat_R=NULL;
    $ser_add_nat_P=NULL;
    $ser_add_nat_R=NULL;
 
    $message='NAT setting is successfully saved. All changes will take effect when you start FirstSpot next time.';
    $saved='true';
    $errorlog='';
    //free COM object
    //$settingobj->Release();
    $settingobj=null;
} //end NAT service settings

/**
 *  UI customization settings
 */
else if (isset($save_lang) && $save_lang=='true')
{
    // create COM object
    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('settingok.php FSCONFIG.Cfgmgr Object cannot be created!');
    $cat = 'lang';
    $msg= '';

    $langdir = "..\\authserv\\lang\\";
    $defaultLangFile = $settingobj->getKey('default_lang_file', 'lang');
    $lang_pack_file = $settingobj->getKey('lang_pack_file', 'lang');

    /**
    * edit UI settings
    */

    // login page picture
    if (isset($loginpage_pic)){
		$filter_path = realpath("..\\");
		$filter_path = $filter_path."\\config.ini";
		$i=sizeof($loginpage_pic);
		$settingobj->WriteINI("gateway", "loginpage_pic_count", $i, $filter_path);
		$y=0;
		while($y<$i){
			$name="loginpage_pic";
			$name.=$y;
			$settingobj->WriteINI("gateway", $name, $loginpage_pic[$y], $filter_path);
			$y++;
		}
        //$rsult = $settingobj->setKey($parentList[0], 'loginpage_pic_name', 'gateway');
	}
	
	//check if the admin want to randomize the loginpage pic
	if (isset($random)) {
		$filter_path = realpath("..\\");
		$filter_path = $filter_path."\\config.ini";
		$settingobj->WriteINI("gateway", "random", '1', $filter_path);
	}
	else {
		$filter_path = realpath("..\\");
		$filter_path = $filter_path."\\config.ini";
		$settingobj->WriteINI("gateway", "random",'0', $filter_path);
	}
	$html_address[0]=$html0;
	$html_address[1]=$html1;
	$html_address[2]=$html2;
	$html_address[3]=$html3;
	$html_address[4]=$html4;
	$html_address[5]=$html5;
	$html_address[6]=$html6;
	$html_address[7]=$html7;
	$html_address[8]=$html8;
	$html_address[9]=$html9;
	$html_address[10]=$html10;
	$html_address[11]=$html11;
	$html_address[12]=$html12;
	$html_address[13]=$html13;
	$html_address[14]=$html14;
	$html_address[15]=$html15;
	$html_address[16]=$html16;
	$html_address[17]=$html17;
	$html_address[18]=$html18;
	$html_address[19]=$html19;
	
	$x=0;
	while($x<20){
		$html_fname="loginpage_pic_html";
		$html_fname.=$x;
		
		if(isset($html_address[$x])){
			$filter_path = realpath("..\\");
			$filter_path = $filter_path."\\config.ini";
			$settingobj->WriteINI("gateway", $html_fname,$html_address[$x], $filter_path);
		}
		$x++;
	}
	
	if (isset($redirectpage_pic_name))
		if($redirectpage_pic_name==get_cm_var('setcfg_ui_login_pic_no_pic_chosen'))
			$redirectpage_pic_name="";
        $rsult = $settingobj->setKey($redirectpage_pic_name, 'redirectpage_pic_name', 'gateway');
	
	if	(isset($redirectpage_pic_html))
		$rsult = $settingobj->setKey($redirectpage_pic_html, 'redirectpage_pic_name_html', 'gateway');
			
    // infobox
    if (isset($show_infobox))
        $rsult = $settingobj->setKey($show_infobox, 'show_infobox', 'gateway');
    else
        $rsult = $settingobj->setKey('off', 'show_infobox', 'gateway');
    
    if (isset($show_infobox) && isset($check_infobox_closed))
    	$rsult = $settingobj->setKey($check_infobox_closed, 'check_infobox_closed', 'gateway');
    else 
    	$rsult = $settingobj->setKey('off', 'check_infobox_closed', 'gateway');
    	
	if(isset($infobox_port))
       $rsult=$settingobj->setKey($infobox_port, 'infobox_port', 'gateway');

    if (isset($show_cart))
        $rsult = $settingobj->setKey($show_cart, 'show_cart', 'misc');
    else
        $rsult = $settingobj->setKey('no', 'show_cart', 'misc');

    if (isset($enable_chgpwd))
        $rsult = $settingobj->setKey('1', 'enable_chgpwd', 'misc');
    else
        $rsult = $settingobj->setKey('0', 'enable_chgpwd', 'misc');

    if (isset($time_reminder))
        $rsult = $settingobj->setKey('1', 'time_reminder', 'misc');
    else
        $rsult = $settingobj->setKey('0', 'time_reminder', 'misc');

    if (isset($remindMin))
        $rsult = $settingobj->setKey($remindMin, 'remindMin', 'misc');

    // [sphl] 20070216 moved from Authentication Server
    if(isset($start_up_redirect_option ))
		$rsult = $settingobj->setKey($start_up_redirect_option , 'start_up_redirect_option', 'gateway');
		
	if(isset($start_up_redirect_url))
		$rsult = $settingobj->setKey($start_up_redirect_url, 'start_up_redirect_url', 'gateway');

	if(isset($start_up_redirect_wait ))
		$rsult = $settingobj->setKey($start_up_redirect_wait , 'start_up_redirect_wait', 'gateway');
	
        
        
    // language
    if (isset($show_charset))
        $rsult = $settingobj->setKey('1', 'show_charset', 'lang');
    else
        $rsult = $settingobj->setKey('0', 'show_charset', 'lang');

    // edit language file attributes
    if (isset($_POST['edit']) && $_POST['edit']=='true') {
        $langattr = $_POST['lang_desc'].';'.$_POST['lang_region'].';'.$_POST['lang_charset'];
        if ($select_lang[0]=='0')
            $rsult = $settingobj->setKey($langattr, 'default_lang_file_attributes', 'lang');
        else
            $rsult = $settingobj->setKey($langattr, 'lang_file'.$select_lang[0].'_attributes', 'lang');
    }

    // delete language file(s)
    if (isset($_POST['del']) && $_POST['del']=='true') {
        $deleted = array();
        // delete the file and the infomation stored in config.ini
        foreach ($_POST['select_lang'] as $value) {
            if ($value != '0') {    // ignore the default language file
                $delfile = $settingobj->getKey("lang_file$value", 'lang');
                if (unlink($langdir.$delfile)) {
                    $rsult = $settingobj->setKey('', "lang_file$value", 'lang');
                    $rsult = $settingobj->setKey('', "lang_file$value".'_attributes', 'lang');
                    $deleted[] = $value;
                } else
                    $msg .= "<br>\nDelete $delfile failed!";
            }
        }
        $msg .= "<br>\n".count($deleted).' language file(s) deleted.';

        // rearrange the lang_file information in config.ini
        $savefile = array();
        $saveattr = array();
        $arr = array();
        $lfnum = $settingobj->getKey('lang_fileNumber', 'lang');
        // initialize the array
        for ($i = 1; $i <= $lfnum; $i++)
            $arr[] = $i;
        // compare with the deleted array
        $arr = array_diff($arr, $deleted);
        // get the remaining files information
        foreach ($arr as $value) {
            $savefile[] = $settingobj->getKey("lang_file$value", 'lang');
            $saveattr[] = $settingobj->getKey("lang_file$value".'_attributes', 'lang');
        }
        // clear language file information
        for ($i = 1; $i <= $lfnum; $i++) {
            $rsult = $settingobj->setKey('', "lang_file$i", 'lang');
            $rsult = $settingobj->setKey('', "lang_file$i".'_attributes', 'lang');
        }
        // fill in the information
        foreach ($savefile as $key => $value) {
            $index = $key+1;
            $rsult = $settingobj->setKey($value, "lang_file".$index, 'lang');
            $rsult = $settingobj->setKey($saveattr[$key], "lang_file$index".'_attributes', 'lang');
        }
        // save the number of language files
        $rsult = $settingobj->setKey(count($savefile), 'lang_fileNumber', 'lang');
    }

    $message = 'UI settings are successfully saved.All changes will take effect when you start FirstSpot next time'.$msg;

    /**
    * edit default language file content
    */
    if (isset($_POST['editfile']) && $_POST['editfile']=='true') {
        $value=$settingobj->getKey('lang_pack_file', 'lang');
        $value=$langdir.$value;

        if (chmod($value, 0666)) {
            if (($fp = fopen($value,'w+')) == TRUE) {
                fwrite($fp, "<?php\r\n");

                include_once $langdir.$defaultLangFile;
                function save_line($element, $val, $fp)
                {
                    global $lang;
                    if( !(isset($lang[$element]) && ($lang[$element] == $val)) ) {
                        // convert all applicable characters to HTML entities
                        $val = htmlentities($val, ENT_QUOTES);
                        // write to file
                        $stringtowrite = "$"."lang['".$element."'] = '".$val."';\r\n";
                        fwrite($fp, $stringtowrite);
                    }
                }

                function save_cmt($element, $fp)
                {
                    $stringtowrite = "// ".$element."\r\n"; 
                    fwrite($fp, $stringtowrite);    
                }

                save_cmt('login.php', $fp);
                save_line('greeting', $greeting, $fp);
                save_line('language', $language , $fp);
                save_line('user_name', $user_name, $fp);
                save_line('anonymous', $anonymous, $fp);    
                save_line('Password', $Password, $fp);
                save_line('logged', $logged, $fp);
                save_line('no_usage', $no_usage, $fp);
                save_line('invalid', $invalid, $fp);
                save_line('example', $example, $fp);
                save_line('free_website', $free_website, $fp);
                save_line('invalid_access', $invalid_access, $fp);
                save_line('ok_btn', $ok_btn, $fp);
                save_line('cookies', $cookies, $fp);
                save_line('submit_btn', $submit_btn, $fp);
                save_line('sign_up_now', $sign_up_now, $fp);

                save_cmt('info.php', $fp);
                save_line('info_title', $info_title, $fp);
                save_line('info_expired', $info_expired, $fp);
                save_line('info_please_logout', $info_please_logout, $fp);  
                save_line('info_please_login_again', $info_please_login_again, $fp);
                save_line('info_access_min_remain', $info_access_min_remain, $fp);
                save_line('info_if_close', $info_if_close, $fp);
                save_line('info_logout', $info_logout, $fp);
                save_line('info_in_browser', $info_in_browser, $fp);
                save_line('info_thank_you', $info_thank_you, $fp);
                save_line('info_logout_btn', $info_logout_btn, $fp);
                save_line('info_cart_btn', $info_cart_btn, $fp);
                save_line('info_chgpwd_btn', $info_chgpwd_btn, $fp);

                save_cmt('signup_form.php', $fp);
                save_line('signup_form', $signup_form, $fp);
                save_line('signup_username', $signup_username, $fp);
                save_line('signup_pwd1', $signup_pwd1, $fp);    
                save_line('signup_pwd2', $signup_pwd2, $fp);
                save_line('signup_submit_btn', $signup_submit_btn, $fp);
                

                save_cmt('chgpwd_form.php', $fp);
                save_line('chgpwd_form', $chgpwd_form, $fp);
                save_line('chgpwd_username', $chgpwd_username, $fp);
                save_line('chgpwd_oldpwd', $chgpwd_oldpwd, $fp);
                save_line('chgpwd_pwd1', $chgpwd_pwd1, $fp);    
                save_line('chgpwd_pwd2', $chgpwd_pwd2, $fp);
                save_line('chgpwd_submit_btn', $chgpwd_submit_btn, $fp);

                save_cmt('fs_chgpwd.php', $fp);
                save_line('chgpwd_ok_header', $chgpwd_ok_header, $fp);
                save_line('chgpwd_ok_link', $chgpwd_ok_link, $fp);
                save_line('chgpwd_fail_header', $chgpwd_fail_header, $fp);  
                save_line('chgpwd_fail_link', $chgpwd_fail_link, $fp);
                save_line('chgpwd_problem_id_empty', $chgpwd_problem_id_empty, $fp);
                save_line('chgpwd_problem_old_pwd_empty', $chgpwd_problem_old_pwd_empty, $fp);
                save_line('chgpwd_problem_new_pwd_empty', $chgpwd_problem_new_pwd_empty, $fp);
                save_line('chgpwd_problem_pwd_mismatch', $chgpwd_problem_pwd_mismatch, $fp);
                save_line('chgpwd_problem_id_not_exists', $chgpwd_problem_id_not_exists, $fp);
                save_line('chgpwd_problem_old_pwd_mismatch', $chgpwd_problem_old_pwd_mismatch, $fp);
                save_line('chgpwd_problem_access_right', $chgpwd_problem_access_right, $fp);

                save_cmt('logout.php', $fp);
                save_line('are_anonymous', $are_anonymous, $fp);
                save_line('logout', $logout, $fp);
                save_line('back_btn', $back_btn, $fp);  
                save_line('login_fail', $login_fail, $fp);
                save_line('login_success', $login_success, $fp);
                //save_line('Timeleft', $Timeleft, $fp);
                save_line('Unlimited', $Unlimited, $fp);
                save_line('Min', $Min, $fp);
                save_line('last_than_one_min', $last_than_one_min, $fp);

                save_cmt('redirect.php', $fp);
                save_line('redirect_title', $redirect_title, $fp);
                save_line('redirect_wait', $redirect_wait, $fp);
                save_line('redirect_msg', $redirect_msg, $fp);

                save_cmt('disconnect.php', $fp);
                save_line('Disconnected', $Disconnected, $fp);
                save_line('signed_success', $signed_success, $fp);

                save_cmt('fs_signup.php', $fp);
                save_line('signup_ok_header', $signup_ok_header, $fp);
                save_line('signup_ok_link', $signup_ok_link, $fp);
                save_line('signup_fail_header', $signup_fail_header, $fp);  
                save_line('signup_fail_link', $signup_fail_link, $fp);
                save_line('signup_problem_id_empty', $signup_problem_id_empty, $fp);
                save_line('signup_problem_pwd_empty', $signup_problem_pwd_empty, $fp);
                save_line('signup_problem_pwd_mismatch', $signup_problem_pwd_mismatch, $fp);
                save_line('signup_problem_id_duplicate', $signup_problem_id_duplicate, $fp);
                save_line('signup_problem_field_empty', $signup_problem_field_empty, $fp);

                save_cmt('welcome.php', $fp);
                save_line('browse_freely', $browse_freely, $fp);
                save_line('not_support_frames', $not_support_frames, $fp);
                save_line('alert', $alert, $fp);    

                save_cmt('cart.php', $fp);
                save_line('cart_welcome', $cart_welcome, $fp);
                save_line('cart_check_timeleft', $cart_check_timeleft, $fp);
                save_line('cart_check_txn', $cart_check_txn, $fp);  
                save_line('cart_shopping_cart', $cart_shopping_cart, $fp);
                save_line('cart_desc', $cart_desc, $fp);
                save_line('cart_price', $cart_price, $fp);
                save_line('cart_checkout', $cart_checkout, $fp);

                save_cmt('cookies_warning.php', $fp);
                save_line('cookies_warning', $cookies_warning, $fp);

                save_cmt('timeleft.php', $fp);
                save_line('timeleft_header', $timeleft_header, $fp);
                //save_line('timeleft_less_than_1min', $timeleft_less_than_1min, $fp);
                //save_line('timeleft_unlimited', $timeleft_unlimited, $fp);    

                save_cmt('paypal_history.php', $fp);
                save_line('ppal_history_title', $ppal_history_title, $fp);
                save_line('ppal_history_col1', $ppal_history_col1, $fp);
                save_line('ppal_history_col2', $ppal_history_col2, $fp);    
                save_line('ppal_history_col3', $ppal_history_col3, $fp);
                save_line('ppal_history_col4', $ppal_history_col4, $fp);
                save_line('ppal_history_col5', $ppal_history_col5, $fp);
                //save_line('ppal_history_col6', $ppal_history_col6, $fp);
                //save_line('ppal_history_col7', $ppal_history_col7, $fp);
                save_line('ppal_history_status_empty', $ppal_history_status_empty, $fp);
                save_line('ppal_history_status_pendingN', $ppal_history_status_pendingN, $fp);
                save_line('ppal_history_status_pendingY', $ppal_history_status_pendingY, $fp);
                save_line('ppal_history_status_completed', $ppal_history_status_completed, $fp);
                save_line('ppal_history_status_refunded', $ppal_history_status_refunded, $fp);
                save_line('wpay_history_status_cancelled', $wpay_history_status_cancelled, $fp);

                save_cmt('Printing support', $fp);
                save_line('print_support', $print_support, $fp);
                save_line('print_ref_id', $print_ref_id, $fp);
                save_line('print_page_count', $print_page_count, $fp);
                save_line('print_page_left', $print_page_left, $fp);    
                save_line('print_username', $print_username, $fp);
                save_line('print_password', $print_password, $fp);
                save_line('print_error_token', $print_error_token, $fp);
                save_line('print_error_quota', $print_error_quota, $fp);
                save_line('print_error_pwd', $print_error_pwd, $fp);

                save_cmt('Extra Information Fields for Anonymous Login', $fp);
                save_line('extra_field1', $extra_field1, $fp);
                save_line('extra_field2', $extra_field2, $fp);
                save_line('extra_field3', $extra_field3, $fp);
                save_line('extra_field4', $extra_field4, $fp);
                save_line('extra_field5', $extra_field5, $fp);
                save_line('extra_field6', $extra_field6, $fp);
                save_line('extra_field7', $extra_field7, $fp);
                save_line('extra_field8', $extra_field8, $fp);
                save_line('extra_field9', $extra_field9, $fp);
                save_line('extra_field10', $extra_field10, $fp);
                save_line('extra_field_err_empty', $extra_field_err_empty, $fp);
                
                $arr = array('01', '02', '03', '04', '05', '06', '07', '08', '09', '10');

                foreach ($arr as $n) {
                    if(isset(${"extra$n"}))
                        $rsult = $settingobj->setKey(${"extra$n"}, "extra$n", 'lang');
                    else
                        $rsult = $settingobj->setKey('off', "extra$n", 'lang');
                }

                if(isset($Datasource_extra_field_table))
                    $rsult=$settingobj->setKey($Datasource_extra_field_table, 'Datasource_extra_field_table', 'gateway');
                save_cmt('ReqSignUp_form.php', $fp);
                save_line('ReqSignUp_title', $ReqSignUp_title, $fp);
                save_line('ReqSignUp_header', $ReqSignUp_header, $fp);
                save_line('ReqSignUp_submit_btn', $ReqSignUp_submit_btn, $fp);
                
                save_cmt('fs_ReqSignUp.php', $fp);
                save_line('ReqSignUp_extra1', $ReqSignUp_extra1, $fp);
                save_line('ReqSignUp_extra2', $ReqSignUp_extra2, $fp);
                save_line('ReqSignUp_extra3', $ReqSignUp_extra3, $fp);
                save_line('ReqSignUp_extra4', $ReqSignUp_extra4, $fp);
                save_line('ReqSignUp_extra5', $ReqSignUp_extra5, $fp);
                save_line('ReqSignUp_extra6', $ReqSignUp_extra6, $fp);
                save_line('ReqSignUp_extra7', $ReqSignUp_extra7, $fp);
                save_line('ReqSignUp_extra8', $ReqSignUp_extra8, $fp);
                save_line('ReqSignUp_extra9', $ReqSignUp_extra9, $fp);
                save_line('ReqSignUp_extra10', $ReqSignUp_extra10, $fp);
                
                save_line('ReqSignUp_ok_header', $ReqSignUp_ok_header, $fp);
                save_line('ReqSignUp_ok_link', $ReqSignUp_ok_link, $fp);
                save_line('ReqSignUp_fail_header', $ReqSignUp_fail_header, $fp);
                save_line('ReqSignUp_fail_link', $ReqSignUp_fail_link, $fp);
                save_line('ReqSignUp_problem_field_empty', $ReqSignUp_problem_field_empty, $fp);

                foreach ($arr as $n) {
                    if(isset(${"ReqSignUp$n"}))
                        $rsult = $settingobj->setKey(${"ReqSignUp$n"}, "ReqSignUp$n", 'lang');
                    else
                        $rsult = $settingobj->setKey('off', "ReqSignUp$n", 'lang');
                }
                fwrite($fp, "?>");

                fclose($fp);

                $message.="<br>\nLanguage pack variables are successfully saved.";
            } else
                $message.="<br>\nLanguage pack cannot open.";
        } else
            $message.="<br>\nLanguage pack file is readonly.";
    } // end edit file

    $saved='true';
    $errorlog='';
    //free COM object
    //$settingobj->Release();
    $settingobj=null;
}

##KK credit card
else if(isset($save_cc) && $save_cc=='true')
{
    $cat='cc';
    if(strtolower($version)!='start') {
        $settingobj = new COM('FSCONFIG.Cfgmgr') or die('settingok.php FSCONFIG.Cfgmgr Object cannot be created!');
        if (isset($exportCCLog)&&($exportCCLog == true)) {
            include_once("..\\authserv\\common_functions.php");

            $credit_card_log="..\\log\\creditcardlog.csv";
            if (is_file($credit_card_log) == TRUE)
                unlink($credit_card_log);
            if (is_file($credit_card_log) == FALSE) {
                touch ($credit_card_log);
                $log_msg_heading="DATE,USER,STATUS,PLAN,AMT,QTY,ITEM NAME,METHOD\r\n";
                $fileHandler = fopen ($credit_card_log, 'w');
                fwrite ($fileHandler, $log_msg_heading);
                fclose ($fileHandler);
            }

            $buff = file_get_contents($credit_card_log);
            $fileHandler = fopen ($credit_card_log, 'w');

            if (!flock ($fileHandler, LOCK_EX )) // exclusive lock
                $message .= 'Fail to lock the log file. ';

            $ppal_table=$settingobj->getKey('Datasource_PayPal_Table', 'gateway');

            $q="SELECT * from ".$ppal_table.";";

            $result=db_query($q);

            $log_msg_content = '';

            while(odbc_fetch_row($result)) {
                $date=date("M-d H:i",floor(odbc_result($result,'ORDER_DATE')));
                $user=odbc_result($result,'USERNAME');
                $pay_status=odbc_result($result,'PAY_STATUS');
                $plan=odbc_result($result,'PLANNAME');
                $amt=odbc_result($result,'AMOUNT');
                $qty=odbc_result($result,'QUANTITY');
                $item_name=odbc_result($result,'ITEM_NAME');
                $method=odbc_result($result,'METHOD');

                $log_msg_content.=$date.",".$user.",".$pay_status.",".$plan.",".$amt.",".$qty.",".$item_name.",".$method."\r\n";
            }

            fwrite ($fileHandler, $buff.$log_msg_content);
            flock ($fileHandler, LOCK_UN ); // release the lock
            fclose ($fileHandler);

            $message='All credit card log have been exported.';
            $saved='true';
            $errorlog='';
        } else if($payment_select == 'ppal') {
            $rsult=$settingobj->setKey($payment_select, 'payment_method', 'creditcard');

            if(isset($ppal_business))
                $rsult=$settingobj->setKey($ppal_business, 'ppal_business', 'paypal');

            if(isset($ppal_return))
                $rsult=$settingobj->setKey($ppal_return, 'ppal_return', 'paypal');

            if(isset($ppal_cancal_return))
                $rsult=$settingobj->setKey($ppal_cancal_return, 'ppal_cancel_return', 'paypal');

            if(isset($ppal_pending_release))
                $rsult=$settingobj->setKey($ppal_pending_release, 'ppal_pending_release', 'paypal');

            if(isset($ppal_base_currency))
                $rsult=$settingobj->setKey($ppal_base_currency, 'ppal_base_currency', 'paypal');

            if(isset($ppal_notify_url))
                $rsult=$settingobj->setKey($ppal_notify_url, 'ppal_notify_url', 'paypal');

            //##KK 9 DEC ssl port, invoice_start
            if(isset($ssl_port))
                $rsult=$settingobj->setKey($ssl_port, 'ssl_port', 'gateway');

            if(isset($Datasource_PayPal_Table))
                $rsult=$settingobj->setKey($Datasource_PayPal_Table, 'Datasource_PayPal_Table', 'gateway');

            //#######

            $message='Credit card setting is successfully saved. All changes will take effect when you start FirstSpot next time.';
            $saved='true';
            $errorlog='';
        } else if ($payment_select == 'worldpay') {
            $rsult=$settingobj->setKey($payment_select, 'payment_method', 'creditcard');

            if(isset($wpay_instID))
                $rsult=$settingobj->setKey($wpay_instID, 'wpay_instID', 'worldpay');

            if(isset($ppal_return))
                $rsult=$settingobj->setKey($ppal_return, 'ppal_return', 'paypal');

            if(isset($ppal_cancal_return))
                $rsult=$settingobj->setKey($ppal_cancal_return, 'ppal_cancel_return', 'paypal');

            if(isset($wpay_base_currency))
                $rsult=$settingobj->setKey($wpay_base_currency, 'wpay_base_currency', 'worldpay');

            if(isset($wpay_notify_url))
                $rsult=$settingobj->setKey($wpay_notify_url, 'wpay_notify_url', 'worldpay');

            if(isset($wpay_testmode))
                $rsult=$settingobj->setKey($wpay_testmode, 'wpay_testmode', 'worldpay');

            if(isset($ssl_port))
                $rsult=$settingobj->setKey($ssl_port, 'ssl_port', 'gateway');

            if(isset($Datasource_PayPal_Table))
                $rsult=$settingobj->setKey($Datasource_PayPal_Table, 'Datasource_PayPal_Table', 'gateway');

            $message='Credit card setting is successfully saved. All changes will take effect when you start FirstSpot next time.';
            $saved='true';
            $errorlog='';
        } else if ($payment_select == 'authorizeNet') {
            $rsult=$settingobj->setKey($payment_select, 'payment_method', 'creditcard');

            if(isset($aNet_id))
                $rsult=$settingobj->setKey($aNet_id, 'aNet_id', 'AuthorizeNet');

            if(isset($ppal_return))
                $rsult=$settingobj->setKey($ppal_return, 'ppal_return', 'paypal');

            if(isset($ppal_cancal_return))
                $rsult=$settingobj->setKey($ppal_cancal_return, 'ppal_cancel_return', 'paypal');

            if(isset($aNet_key))
                $rsult=$settingobj->setKey($aNet_key, 'aNet_key', 'AuthorizeNet');

            if(isset($aNet_hash))
                $rsult=$settingobj->setKey($aNet_hash, 'aNet_hash', 'AuthorizeNet');

            if(isset($aNet_base_currency))
                $rsult=$settingobj->setKey($aNet_base_currency, 'aNet_base_currency', 'AuthorizeNet');

            if(isset($aNet_notify_url))
                $rsult=$settingobj->setKey($aNet_notify_url, 'aNet_notify_url', 'AuthorizeNet');

            if(isset($aNet_testmode))
                $rsult=$settingobj->setKey($aNet_testmode, 'aNet_testmode', 'AuthorizeNet');

            if(isset($Datasource_PayPal_Table))
                $rsult=$settingobj->setKey($Datasource_PayPal_Table, 'Datasource_PayPal_Table', 'gateway');

            $message='Credit card setting is successfully saved. All changes will take effect when you start FirstSpot next time.';
            $saved='true';
            $errorlog='';
		} else if($payment_select == 'checkout') {
            $rsult=$settingobj->setKey($payment_select, 'payment_method', 'creditcard');

            if(isset($checkout_merchant_id))
                $rsult=$settingobj->setKey($checkout_merchant_id, 'checkout_merchant_id', 'googleCheckout');

            if(isset($checkout_return))
                $rsult=$settingobj->setKey($checkout_return, 'checkout_return', 'googleCheckout');

            if(isset($checkout_cancel_return))
                $rsult=$settingobj->setKey($checkout_cancel_return, 'checkout_cancel_return', 'googleCheckout');

            if(isset($checkout_base_currency))
                $rsult=$settingobj->setKey($checkout_base_currency, 'checkout_base_currency', 'googleCheckout');

            //##KK 9 DEC ssl port, invoice_start
            if(isset($ssl_port))
                $rsult=$settingobj->setKey($ssl_port, 'ssl_port', 'gateway');

            if(isset($Datasource_PayPal_Table))
                $rsult=$settingobj->setKey($Datasource_PayPal_Table, 'Datasource_PayPal_Table', 'gateway');

            //#######

            $message='Credit card setting is successfully saved. All changes will take effect when you start FirstSpot next time.';
            $saved='true';
            $errorlog='';
        } else if ($payment_select == 'user_defined') {
            $rsult=$settingobj->setKey($payment_select, 'payment_method', 'creditcard');

            if(isset($udef_id))
                $rsult=$settingobj->setKey($udef_id, 'id', 'User_defined_payment');

            if(isset($udef_return))
                $rsult=$settingobj->setKey($udef_return, 'ppal_return', 'paypal');

            if(isset($udef_cancel_return))
                $rsult=$settingobj->setKey($udef_cancel_return, 'ppal_cancel_return', 'paypal');

            if(isset($udef_pin1))
                $rsult=$settingobj->setKey($udef_pin1, 'pin1', 'User_defined_payment');

            if(isset($udef_pin2))
                $rsult=$settingobj->setKey($udef_pin2, 'pin2', 'User_defined_payment');

            if(isset($udef_currency))
                $rsult=$settingobj->setKey($udef_currency, 'currency', 'User_defined_payment');

            if(isset($udef_notify_url))
                $rsult=$settingobj->setKey($udef_notify_url, 'notify_url', 'User_defined_payment');

            if(isset($udef_ssl_port))
                $rsult=$settingobj->setKey($udef_ssl_port, 'ssl_port', 'gateway');

            if(isset($udef_txn_table))
                $rsult=$settingobj->setKey($udef_txn_table, 'Datasource_PayPal_Table', 'gateway');

            $message='Credit card setting is successfully saved. All changes will take effect when you start FirstSpot next time.';
            $saved='true';
            $errorlog='';
        }
        //$settingobj->Release();
        $settingobj=null;
    } // end version start
}
##end credit card

// authentication server services
else if(isset($save_a) && $save_a=='true')
{
    $cat='a';
    $resetAttemptMsg=false;  
    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('settingok.php FSCONFIG.Cfgmgr Object cannot be created!');
    //************************************************************************************
    //Scenario 2 (Distributed Network Topology) Hans 19 MAY 2004
    if(isset($scenario2))
        $rsult = $settingobj->setKey($scenario2, 'scenario2','gateway');
    //************************************************************************************

    if(isset($auth_port)) {
        $rsult = $settingobj->setKey($auth_port, 'auth_port', 'gateway');
        $ssl_status= $settingobj->getKey( 'rewrite_engine', 'gateway');
        if ($ssl_status=='off')
            $rsult = $settingobj->setKey($auth_port, 'ssl_auth_port', 'gateway');

    }

    if(isset($ssl_auth_port)) {
        $a_port= $settingobj->getKey('auth_port', 'gateway');
        $rsult = $settingobj->setKey($ssl_auth_port, 'ssl_auth_port', 'gateway');
        if ($ssl_auth_port==$a_port)
            $rsult = $settingobj->setKey('off', 'rewrite_engine', 'gateway');
        else
            $rsult = $settingobj->setKey('on', 'rewrite_engine', 'gateway');
    }        

	if (isset($loginpage_pic)){
		$filter_path = realpath("..\\");
		$filter_path = $filter_path."\\config.ini";
		$i=sizeof($loginpage_pic);
		$settingobj->WriteINI("gateway", "loginpage_pic_count", $i, $filter_path);
		$y=0;
		while($y<$i){
			$name="loginpage_pic";
			$name.=$y;
			$settingobj->WriteINI("gateway", $name, $loginpage_pic[$y], $filter_path);
			$y++;
		}
        //$rsult = $settingobj->setKey($parentList[0], 'loginpage_pic_name', 'gateway');
	}
	
	//check if the admin want to randomize the loginpage pic
	if (isset($random)) {
		$filter_path = realpath("..\\");
		$filter_path = $filter_path."\\config.ini";
		$settingobj->WriteINI("gateway", "random", '1', $filter_path);
	}
	else {
		$filter_path = realpath("..\\");
		$filter_path = $filter_path."\\config.ini";
		$settingobj->WriteINI("gateway", "random",'0', $filter_path);
	}
	
	
	if (isset($redirectpage_pic_name))
        $rsult = $settingobj->setKey($redirectpage_pic_name, 'redirectpage_pic_name', 'gateway');
	
	if	(isset($redirectpage_pic_html))
		$rsult = $settingobj->setKey($redirectpage_pic_html, 'redirectpage_pic_name_html', 'gateway');
	
    if(isset($anonymous_login_cb)||strtolower($version) == 'start'){
        $rsult = $settingobj->setKey('on', 'anonymous_login', 'gateway');
        if (isset($secret_enable)){
            $rsult = $settingobj->setKey('on', 'secret_enable', 'gateway');
            if (isset($ssecret_tablename)){
                $rsult = $settingobj->setKey($ssecret_tablename, 'Datasource_Shared_Secret_Tablename', 'gateway');
            }
        } else {
            $rsult = $settingobj->setKey('off', 'secret_enable', 'gateway');
        }
    } else {
        $rsult = $settingobj->setKey('off', 'anonymous_login', 'gateway');
        $rsult = $settingobj->setKey('off', 'secret_enable', 'gateway');
    }

    if(isset($loginpage))
        $rsult = $settingobj->setKey($loginpage, 'loginpage', 'gateway');

    if(isset($maxAttempt))
        $rsult = $settingobj->setKey($maxAttempt, 'max_attempt', 'gateway');  

    //added by Jason 15-03-2004
    if(isset($rewrite_engine)) {
        $a_port= $settingobj->getKey('auth_port', 'gateway');
        $rsult = $settingobj->setKey($rewrite_engine, 'rewrite_engine', 'gateway');
        if ($rewrite_engine=='off')
            $rsult = $settingobj->setKey($a_port, 'ssl_auth_port', 'gateway');
        else
            $rsult = $settingobj->setKey('443', 'ssl_auth_port', 'gateway');
    }

    if(isset($resetAttempt) && $resetAttempt==-1) {
        // open dsn
        $dsn_file=$settingobj->getKey('Datasource', 'gateway');
        $dsn_source=fopen($dsn_file, 'r') or die('Cannot open DSN source file!');

        // prepare dsn string for ODBC connection
        $dsn='';

        if(!feof($dsn_source))
            $line=fgets($dsn_source,512);
        // read in each line
        while(!feof($dsn_source)) {
            $line=fgets($dsn_source,512);
            if(trim($line)!='') 
                $dsn=$dsn.$line;
        }

        // replace newline with semicolon
        $dsn=str_replace("\r\n",';',$dsn);

        // connect with ODBC
        $userDB=odbc_connect($dsn,'','');

        // connected
        if($userDB) {
            // for firstspot user table, we reset all reserved fields
            $firstspotusertable=$settingobj->getKey('Datasource_Tablename', 'gateway');
            $query="UPDATE $firstspotusertable SET attempt=0;";
            $result=odbc_exec($userDB,$query);

            // close the odbc connection
            odbc_close($userDB);
            // inform user
            $message='All user\'s fail attempt value are reset.';
            $saved='true';
            $errorlog='';
        } else {
            // warn user if connection failed
            $message='database connection failed!';
            $saved='false';
            $errorlog='database connection failed!';
        }
        $resetAttemptMsg=true;

        $cat='a';
    }
    if(isset($ssl_cert))
        $rsult = $settingobj->setKey($ssl_cert, 'ssl_cert', 'gateway');
    
    if(isset($restricted_redirect))
        $rsult = $settingobj->setKey($restricted_redirect, 'restricted_redirect', 'gateway');

    //************************************************************************************************
    // Authentication ODBC Handling
    if(isset($odbc_selection)&&$odbc_selection=='ODBC') {
        $rsult = $settingobj->setKey('false', 'use_radius', 'radius');

        if(isset($Datasource))
            $rsult = $settingobj->setKey(stripslashes($Datasource), 'Datasource', 'gateway');

        if(isset($Datasource_Tablename))
            $rsult = $settingobj->setKey($Datasource_Tablename, 'Datasource_Tablename', 'gateway');

        if(isset($Datasource_Plans_Tablename))
            $rsult = $settingobj->setKey($Datasource_Plans_Tablename, 'Datasource_Plans_Tablename', 'gateway');

        if(isset($Datasource_Log_Tablename))
            $rsult = $settingobj->setKey($Datasource_Log_Tablename, 'Datasource_Log_Tablename', 'gateway');

        if(isset($Datasource_Anonymous_Tablename))
            $rsult = $settingobj->setKey($Datasource_Anonymous_Tablename, 'Datasource_Anonymous_Tablename', 'gateway');
        //************************************************************************************************
        // Authentication RADIUS Handling
    } else if(isset($radius_selection)&&$radius_selection=='RADIUS') {
        $rsult = $settingobj->setKey('true', 'use_radius', 'radius');

        if(isset($ServerIP))
            $rsult = $settingobj->setKey($ServerIP, 'ServerIP', 'radius');

        if(isset($AuthPort))
            $rsult = $settingobj->setKey($AuthPort, 'AuthPort', 'radius');

        if(isset($AccPort))
            $rsult = $settingobj->setKey($AccPort, 'AccPort', 'radius');

        if(isset($SharedSecret))
            $rsult = $settingobj->setKey($SharedSecret, 'Secret', 'radius');

        if(isset($FSVendorID))
            $rsult = $settingobj->setKey($FSVendorID, 'FSVendorID', 'radius');

        if(isset($LocalDatasource))
            $rsult = $settingobj->setKey(stripslashes($LocalDatasource), 'Datasource', 'radius');

        if(isset($LocalDatasource_Tablename))
            $rsult = $settingobj->setKey($LocalDatasource_Tablename, 'Datasource_Tablename', 'radius');

        if(isset($Acc_Start)&&$Acc_Start=='ON')
            $rsult = $settingobj->setKey('true', 'Acc_Start', 'radius');
        else
            $rsult = $settingobj->setKey('', 'Acc_Start', 'radius');

        if(isset($Acc_Stop)&&$Acc_Stop=='ON')
            $rsult = $settingobj->setKey('true', 'Acc_Stop', 'radius');
        else
            $rsult = $settingobj->setKey('', 'Acc_Stop', 'radius');

        if(isset($Acc_FSLogin)&&$Acc_FSLogin=='ON')
            $rsult = $settingobj->setKey('true', 'Acc_FSLogin', 'radius');
        else
            $rsult = $settingobj->setKey('', 'Acc_FSLogin', 'radius');

        if(isset($Acc_FSLogout)&&$Acc_FSLogout=='ON')
            $rsult = $settingobj->setKey('true', 'Acc_FSLogout', 'radius');
        else
            $rsult = $settingobj->setKey('', 'Acc_FSLogout', 'radius');

        if(isset($Acc_FSWriteLog)&&$Acc_FSWriteLog=='ON')
            $rsult = $settingobj->setKey('true', 'Acc_FSWriteLog', 'radius');
        else
            $rsult = $settingobj->setKey('', 'Acc_FSWriteLog', 'radius');

        if(isset($Acc_FSPrinterOn)&&$Acc_FSPrinterOn=='ON')
            $rsult = $settingobj->setKey('true', 'Acc_FSPrinterOn', 'radius');
        else
            $rsult = $settingobj->setKey('', 'Acc_FSPrinterOn', 'radius');

        if(isset($NAS_IDENTIFIER))
            $rsult = $settingobj->setKey($NAS_IDENTIFIER, 'NAS_IDENTIFIER', 'radiusAuthentication');

        if(isset($NAS_IP_ADDRESS))
            $rsult = $settingobj->setKey($NAS_IP_ADDRESS, 'NAS_IP_ADDRESS', 'radiusAuthentication');

        if(isset($ACCT_STATUS_FSLOGIN))
            $rsult = $settingobj->setKey($ACCT_STATUS_FSLOGIN, 'ACCT_STATUS_FSLOGIN', 'radiusCustomAttribute');

        if(isset($ACCT_STATUS_FSLOGOUT))
            $rsult = $settingobj->setKey($ACCT_STATUS_FSLOGOUT, 'ACCT_STATUS_FSLOGOUT', 'radiusCustomAttribute');

        if(isset($ACCT_STATUS_FSWRITELOG))
            $rsult = $settingobj->setKey( $ACCT_STATUS_FSWRITELOG, 'ACCT_STATUS_FSWRITELOG', 'radiusCustomAttribute');

        if(isset($ACCT_STATUS_FSPRINTERON))
            $rsult = $settingobj->setKey( $ACCT_STATUS_FSPRINTERON, 'ACCT_STATUS_FSPRINTERON', 'radiusCustomAttribute');
    }
    // END - ODBC/RADIUS
    //************************************************************************************************
	
    /*
    // [sphl] 20070216 moved to UI customization page 
    if(isset($start_up_redirect_option ))
		$rsult = $settingobj->setKey($start_up_redirect_option , 'start_up_redirect_option', 'gateway');
		
	if(isset($start_up_redirect_url))
		$rsult = $settingobj->setKey($start_up_redirect_url, 'start_up_redirect_url', 'gateway');

	if(isset($start_up_redirect_wait ))
		$rsult = $settingobj->setKey($start_up_redirect_wait , 'start_up_redirect_wait', 'gateway');
	*/
			
    if(isset($self_sign_up_credit))
        $rsult = $settingobj->setKey($self_sign_up_credit, 'self_sign_up_credit', 'gateway');
    
    if(isset($self_sign_up_plan))
        $rsult = $settingobj->setKey($self_sign_up_plan, 'self_sign_up_plan', 'gateway');

    if(isset($self_sign_up_option))
        $rsult = $settingobj->setKey($self_sign_up_option, 'self_sign_up_option', 'gateway');

    if(isset($redirect_url))
        $rsult = $settingobj->setKey($redirect_url, 'self_sign_up_redirect', 'gateway');

    if(isset($self_signup_filter)) {
        $rsult = $settingobj->setKey($self_signup_filter, 'self_signup_filter', 'gateway');
        if($self_signup_filter == '1')
            $rsult = $settingobj->setKey( '', 'self_signup_period', 'gateway');            
    }

    if(isset($self_signup_period)) {
        if($self_signup_filter == '0')
            $rsult = $settingobj->setKey($self_signup_period, 'self_signup_period', 'gateway');
    }

    if(isset($session_log))
        $rsult = $settingobj->setKey($session_log, 'session_log', 'gateway');
    else
        $rsult = $settingobj->setKey('OFF', 'session_log', 'gateway');

    if(isset($encrypt_path))
        $rsult = $settingobj->setKey(stripslashes($encrypt_path), 'encrypt_path', 'gateway');

    if(isset($pwd_offload))
        $rsult = $settingobj->setKey($pwd_offload, 'pwd_offload', 'gateway');
    else
        $rsult = $settingobj->setKey('off', 'pwd_offload', 'gateway');
        
    //CAPTCHA check
    if(isset($self_sign_up_captcha_check))
        $rsult = $settingobj->setKey($self_sign_up_captcha_check, 'self_sign_up_captcha_check', 'gateway');


    //display following msg when user did NOT set MAX ATTEMPT FIELD
    if(!$resetAttemptMsg) {
        $message='Authentication server setting is successfully saved. All changes will take effect when you start FirstSpot next time.';
        $saved='true';
        $errorlog='';
    }
    //free COM object
    //$settingobj->Release();
    $settingobj=null;
}

// configuration manager settings
else if(isset($save_m) && $save_m=='true')
{
    $cat='m';
    $RestartMsg = '';
    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('settingok.php FSCONFIG.Cfgmgr Object cannot be created!');
    if(isset($user))
        $rsult = $settingobj->setKey($user, 'user', 'gateway');

    if(isset($pass)&&isset($confirmPass)&&($pass===$confirmPass) && $pass!='                    ') {
        $h_pwd = $settingobj->EncryptString($pass);
        $rsult = $settingobj->setKey($h_pwd, 'pass', 'gateway');
    }

    $old_private = $settingobj->getKey('access_from_private', 'gateway');
    $old_public = $settingobj->getKey('access_from_public', 'gateway');

    if ((($old_private == 'off') && isset($access_from_private)) || (($old_private == 'ON') && !isset($access_from_private)) || (($old_public == 'off') && isset($access_from_public)) || (($old_public == 'ON') && !isset($access_from_public)))
        $RestartMsg = 'All changes will take effect when you restart FirstSpot .';

    if(isset($access_from_private))
        $rsult = $settingobj->setKey($access_from_private, 'access_from_private', 'gateway');
    else
        $rsult = $settingobj->setKey('off', 'access_from_private', 'gateway');

    if(isset($access_from_public))
        $rsult = $settingobj->setKey($access_from_public, 'access_from_public', 'gateway');
    else
        $rsult = $settingobj->setKey('off', 'access_from_public', 'gateway');   

    $max_admin_account=$settingobj->getKey('max_admin_account', 'gateway');
    $addErrorMsg = '';
    $addError = false;

    if(isset($mode)&&($mode=='add')) {
        $emptyspace = false;
        $addError = false;
        if ($admin_username == $user) {
            $addErrorMsg = 'Duplicated Account have been added.';
            $emptyspace = true;
            $addError = true;
        } else {
            $i = 0;
            for ($i = 0; $i < $max_admin_account; $i++) {
                $old_admin_username = $settingobj->getKey("admin_username$i", 'gateway');
                if ($old_admin_username == '')
                    $emptyspace = true;
                if ($old_admin_username == $admin_username) {
                    $addErrorMsg = 'Duplicated Account have been added.';
                    $addError = true;
                }
            }
        }

        if ($emptyspace == false) {
            $addErrorMsg = "$addErrorMsg Reach the maximum account number.";
            $addError = true;
        }

        if ($addError == false) {
            $i = 0;
            for ($i = 0; $i < $max_admin_account; $i++) {
                $old_admin_username = $settingobj->getKey("admin_username$i", 'gateway');
                if ($old_admin_username != '')
                    continue;

                if (isset($admin_username))
                    $rsult = $settingobj->setKey($admin_username, "admin_username$i", 'gateway');
                if (isset($admin_password)) {
                    $en_admin_password = $settingobj->EncryptString($admin_password);
                    $rsult = $settingobj->setKey($en_admin_password, "admin_password$i", 'gateway');
                }

                if (isset($parameter)) { 
                    $rsult = $settingobj->setKey($parameter, "admin_parameter$i", 'gateway');
                }
                break;
            }
        }
    }

    if (isset($mode)&&($mode=='edit')) {
        if (isset($admin_username)) {
            $i = 0;
            for ($i = 0; $i < $max_admin_account; $i++) {
                $old_admin_username=$settingobj->getKey("admin_username$i", 'gateway');
                if ($old_admin_username != $admin_username)
                    continue;

                if (isset($admin_password)&&$admin_password!='                    ') {
                    $en_admin_password = $settingobj->EncryptString($admin_password);
                    $rsult = $settingobj->setKey( $en_admin_password, "admin_password$i", 'gateway');
                }

                if (isset($parameter)) { 
                    $rsult = $settingobj->setKey($parameter, "admin_parameter$i", 'gateway');
                }
                break;
            }
        }
    }

    if (isset($mode)&&($mode=='del')) {
        $tok = strtok($selected_operator, ',');

        while ($tok != '') {
            $admin_username = $tok;

            if (isset($admin_username)) {
                $i = 0;
                for ($i = 0; $i < $max_admin_account; $i++) {
                    $old_admin_username=$settingobj->getKey("admin_username$i", 'gateway');
                    if ($old_admin_username != $admin_username)
                        continue;

                    $rsult = $settingobj->setKey('', "admin_username$i", 'gateway');
                    $rsult = $settingobj->setKey('', "admin_password$i", 'gateway');
                    $rsult = $settingobj->setKey('', "admin_parameter$i", 'gateway');
                }
            }
            $tok = strtok(',');
        }
    }

    if ($addError == true)
        $message=$addErrorMsg;
    else
        $message="Configuration Manager setting is successfully saved.$RestartMsg";
    $saved='true';
    $errorlog='';
    //free COM object
    //$settingobj->Release();
    $settingobj=null;
}

// add routing table settings
else if(isset($save_r) && $save_r=="true")
{
    $cat = 'r';
    require_once 'display_list.php';

    // unserialize session data
    if (isset($ser_display_route)&&($ser_display_route!=='')) {
        $display_route = unserialize($ser_display_route);
    }
    if (isset($ser_add_route)&&($ser_add_route!=='')) {
        $add_route = unserialize($ser_add_route);
    }

    // initialize variables
    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('settingok.php FSCONFIG.Cfgmgr Object cannot be created!');

    $str=''; $j=0; $n=0; $m=0;
    $i = 0;

    // save change the display data
    while ($i < $display_route->num_sites) {
        if ($display_route->site_list[$i]->name{0}!='#') {
            $str = $display_route->site_list[$i]->name.' '.$display_route->site_list[$i]->line_no.' '.$display_route->site_list[$i]->span;
            $rsult = $settingobj->setKey($str, "return_path$n", 'MNS');

            if($display_route->site_list[$i]->enable_redirect==TRUE)
                $rsult = $settingobj->setKey('1', "Login_enable$n", 'loginPhp');
            else
                $rsult = $settingobj->setKey('0', "Login_enable$n", 'loginPhp');

            $rsult = $settingobj->setKey($display_route->site_list[$i]->redirect_php, "Login_php_Num$n", 'loginPhp');
            $n++;
        }
        $i++;
    }

    // save the add data
    $j = $n;
    $i = 0;
    while ($i < $add_route->num_sites) {
        if (($add_route->site_list[$i]->name!=';')&&($add_route->site_list[$i]->name{0}!='#')) {
            $str = $add_route->site_list[$i]->name.' '.$add_route->site_list[$i]->line_no.' '.$add_route->site_list[$i]->span;
            $rsult = $settingobj->setKey($str, 'return_path'.($m+$j), 'MNS');

            if($add_route->site_list[$i]->enable_redirect==TRUE)
                $rsult = $settingobj->setKey('1', 'Login_enable'.($m+$j), 'loginPhp');
            else
                $rsult = $settingobj->setKey('0', 'Login_enable'.($m+$j), 'loginPhp');

            $rsult = $settingobj->setKey($add_route->site_list[$i]->redirect_php, 'Login_php_Num'.($m+$j), 'loginPhp');
            $m++;
        }
        $i++;
    }

    $num_return_path = $m+$j;
    $rsult = $settingobj->setKey($num_return_path, 'num_return_path', 'MNS');

    // unset all variables
    $ser_display_route=NULL;
    $ser_add_route=NULL;

    //free COM object
    //$settingobj->Release();
    $settingobj=null;

    $message = 'Routing table setting is successfully saved. All changes will take effect when you start FirstSpot next time.';
    $saved = 'true';
    $errorlog = '';
}


// session handling settings
else if(isset($save_s) && $save_s=='true')
{
    $cat = 's';
    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('settingok.php FSCONFIG.Cfgmgr Object cannot be created!');
    if(isset($session_handling))
        $rsult = $settingobj->setKey($session_handling, 'session_handling', 'gateway');

		//free COM object
    //$settingobj->Release();
    $settingobj=null;

    $message = 'Session Handling setting is successfully saved. All changes will take effect when you start FirstSpot next time.';
    $saved = 'true';
    $errorlog = '';
}

// dhcp settings
else if(isset($save_dhcp) && $save_dhcp=='true')
{
    $cat='dhcp';
    $alert=false;       
    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('settingok.php FSCONFIG.Cfgmgr Object cannot be created!');

    if(isset($servermode)) {
        $rsult = $settingobj->setKey($servermode, 'dhcpmode', 'gateway');
        require_once 'display_list.php';

        if (isset($ser_display_ignore)&&($ser_display_ignore!=='')) 
                $display_ignore=unserialize($ser_display_ignore);
        if (isset($ser_add_ignore)&&($ser_add_ignore!=='')) 
        $add_ignore=unserialize($ser_add_ignore);

        $str=''; $j=0; $n=0; $m=0;
        $i=0;
        while ($i < $display_ignore->num_sites) {
	    // 20080205 - Obtain IP from name field instead of span in display_ignore list
	    if ($display_ignore->site_list[$i]->name{0} != '#') {
		$rsult = $settingobj->setKey($display_ignore->site_list[$i]->name, "ignore_addr$n", 'DHCP');
		$n++;
	    } else {
		//when deleting exception ip in dhcp, delete the same ip in client pass through as well
		if (isset($ser_display_ip)) {
		    $display_ip = unserialize($ser_display_ip); 
		    $num_sites = $display_ip->num_sites;
		    for ($count = 0; $count < $num_sites; $count++) {
			if (strcmp(substr($display_ignore->site_list[$i]->name, 2, strlen($display_ignore->site_list[$i]->name)-2), $display_ip->site_list[$count]->span) == 0) {

			    for ($j = $count; $j < $num_sites; $j++) {
				if (!empty($display_ip->site_list[$j+1]->span)) {
				    $display_ip->site_list[$j]->span = $display_ip->site_list[$j+1]->span;
				    $rsult = $settingobj->setKey($display_ip->site_list[$j]->span, "ip_$j", 'Client Pass');
				}
			    }
			    $display_ip->num_sites--;

			    $rsult = $settingobj->setKey($display_ip->num_sites , 'num_ip_addr', 'Client Pass');
			    $alert = true;

			    if (isset($display_ip)) {
				$ser_display_ip = serialize($display_ip);
			    }

			}//end if
		    }//end for
		}//end if
	    }//end else

                $i++;
        }
        $j=$n;
        $i=0;
        while ($i<$add_ignore->num_sites) {
	    // 20080205 - Obtain IP from name field instead of span in add_ignore list
	    if (($add_ignore->site_list[$i]->name != ';') && ($add_ignore->site_list[$i]->name{0} != '#')) {
		$rsult = $settingobj->setKey($add_ignore->site_list[$i]->name, 'ignore_addr'.($m+$j), 'DHCP');
		$m++;
	    }
                $i++;
            }

        $num_ignored_addr=$m+$j;

        if(isset($num_ignored_addr))
                $rsult = $settingobj->setKey($num_ignored_addr, 'num_ignored_addr', 'DHCP');

        if(isset($leasetime))
                $rsult = $settingobj->setKey($leasetime, 'leasetime', 'DHCP');  

        // unset all variables
        $ser_display_ignore=NULL;
        $ser_add_ignore=NULL;

        if (isset($ser_display_dhcp)&&($ser_display_dhcp!=='')) 
                $display_dhcp=unserialize($ser_display_dhcp);
        if (isset($ser_add_dhcp)&&($ser_add_dhcp!=='')) 
                $add_dhcp=unserialize($ser_add_dhcp);

        $i=0; $j=0;
        unset($delete_list_dhcp);
        while ($i < $display_dhcp->num_sites) {
                if ($display_dhcp->site_list[$i]->name{0}=='#') { 
                    $delete_list_dhcp[$j]=(int)$display_dhcp->site_list[$i]->line_no; $j++;
                }
                $i++;   
            }
        $num_delete_dhcps=$j;

        $i=0; $j=0;
        unset($add_list_dhcp);
        while ($i < $add_dhcp->num_sites) {
                if (($add_dhcp->site_list[$i]->name!=';')&&($add_dhcp->site_list[$i]->name{0}!='#')) {
                    $add_list_dhcp[$j]=$add_dhcp->site_list[$i]->name.' '.$add_dhcp->site_list[$i]->span; $j++;     
                }
                $i++;
            }
            $num_add_dhcps=$j;

        unset($lines);
        if (isset($add_list_dhcp)||isset($delete_list_dhcp)) {
                if(isset($static_dhcp_path)&&($static_dhcp_path!='')) {
                }else
                    $static_dhcp_path = "..\\StaticDHCP.txt";
                $file_to_read=fopen($static_dhcp_path, 'a');
                fclose($file_to_read);
                $file_to_read=fopen($static_dhcp_path, 'r') or die('Cannot read Static DHCP config file');
                $i=0;
                while (!feof($file_to_read)) { $lines[$i]=fgets($file_to_read, MAXLINELEN); $i++; }
                @fclose($file_to_read);

                $file_to_write=fopen($static_dhcp_path, 'w') or die('Cannot write to Static DHCP config file');

                // Write to file omitting the host keywords to be deleted
                $j=0; $k=0;
                if (isset($delete_list_dhcp)) { 
                    while (($k<$i) && ($j<$num_delete_dhcps)) {
                        if ($k>$delete_list_dhcp[$j])
                            $j++;
                        else if ($k<$delete_list_dhcp[$j]) {
                            fputs($file_to_write, $lines[$k]);
                            $k++;
                        } else {
                            $j++; $k++;
                        }
                    }
                }

                while ($k<$i) {
                    fputs($file_to_write, $lines[$k]);
                    $k++;
                }
                // Append the host keywords to be added at the end of the file
                $k=0; 
                if (isset($add_list_dhcp)) {
                    while ($k<$num_add_dhcps) { 
                        fputs($file_to_write, "\r\n".$add_list_dhcp[$k]); 
                        $k++; 
                    }
                }

                @fclose($file_to_write);  
        }

        // unset all the session variables after saving 
        $ser_add_dhcp=NULL;
        $ser_display_dhcp=NULL;
        if(isset($static_dhcp_path)&&($static_dhcp_path!=''))
            $rsult = $settingobj->setKey(stripslashes($static_dhcp_path), 'static_dhcp_path', 'gateway');
        
    }
    if($alert==true) {
        echo '
        <script type="text/javascript">
            alert ("The newly deleted IP(s) will be removed from the Client pass-through in Session Handling as well!")
        </script>';

        $alert=false;
    }

    // prepare to set the DNS settings
    if(isset($preferred_DNS0)||isset($preferred_DNS1)||isset($preferred_DNS2)||isset($preferred_DNS3)) {
        $preferred_DNS="$preferred_DNS0.$preferred_DNS1.$preferred_DNS2.$preferred_DNS3";

        $last_dns1 = $settingobj->getKey('preferred_DNS', 'gateway');
        $dns2 = $settingobj->getKey('alternate_DNS', 'gateway');
        if(strcmp($last_dns1, $preferred_DNS)!=0) {
            $file_to_read=fopen("..\\AllowedHostsIPs.txt", 'r') or die('Cannot read Exception free IP config file');
            $i=0;
            while (!feof($file_to_read)) { $lines[$i]=fgets($file_to_read, MAXLINELEN); $i++; }
            @fclose($file_to_read);

            $file_to_write=fopen("..\\AllowedHostsIPs.txt", 'w') or die('Cannot write to Exception free IP config file');
            $remove=TRUE;
            $x=0;
            while ($x<$i) {
                if(strncmp($lines[$x], $last_dns1, strlen($last_dns1))==0 && strstr($lines[$x], ';') == FALSE&&$remove){
                    fwrite($file_to_write, '');
                    $remove=FALSE;
                }else 
                    fwrite($file_to_write, $lines[$x]);

                $x++;           
            }      
            @fclose($file_to_write);  

            if(strcmp($preferred_DNS, '0.0.0.0')!=0) {
                $file_to_write=fopen("..\\AllowedHostsIPs.txt", 'a') or die('Cannot write to Exception free IP config file');
                fwrite($file_to_write, "\r\n".$preferred_DNS);
                @fclose($file_to_write);  
            }
        }
        $rsult = $settingobj->setKey($preferred_DNS, 'preferred_DNS', 'gateway');
    }

    if(isset($alternate_DNS0)||isset($alternate_DNS1)||isset($alternate_DNS2)||isset($alternate_DNS3)) {
        $alternate_DNS="$alternate_DNS0.$alternate_DNS1.$alternate_DNS2.$alternate_DNS3";

        $last_dns2 = $settingobj->getKey('alternate_DNS', 'gateway');
        $dns1 = $settingobj->getKey('preferred_DNS', 'gateway');
        if(strcmp($last_dns2, $alternate_DNS)!=0) {
            $file_2_read=fopen("..\\AllowedHostsIPs.txt", 'r') or die('Cannot read Exception free IP config file');
            $i=0;
            while (!feof($file_2_read)) { $ln[$i]=fgets($file_2_read, MAXLINELEN); $i++; }
            @fclose($file_2_read);

            $file_2_write=fopen("..\\AllowedHostsIPs.txt", 'w') or die('Cannot write to Exception free IP config file');

            $remove = TRUE;
            $x=0;
            while ($x<$i) {
                if(strncmp($ln[$x], $last_dns2, strlen($last_dns2))==0 && strstr($ln[$x], ';') == FALSE&&$remove) {
                    fwrite($file_2_write, '');
                    $remove=FALSE;
                } else 
                    fwrite($file_2_write, $ln[$x]);

                $x++;           
            }
            @fclose($file_2_write);  

            if(strcmp($alternate_DNS, '0.0.0.0')!=0) {
                $file_2_write=fopen("..\\AllowedHostsIPs.txt", 'a') or die('Cannot write to Exception free IP config file');
                fwrite($file_2_write, "\r\n".$alternate_DNS);
                @fclose($file_2_write);  
            }
        }

        $rsult = $settingobj->setKey($alternate_DNS, 'alternate_DNS', 'gateway');
    }

    //free COM object
    //$settingobj->Release();
    $settingobj=null;

    $message='DHCP setting is successfully saved. All changes will take effect when you start FirstSpot next time.';
    $saved='true';
    $errorlog='';
}

// Exception free sites
else if ((isset($save_e) && $save_e=='true'))
{
    $cat='e';
    // unserialize data
    require_once 'display_list.php';

    if (isset($ser_display)&&($ser_display!==''))
        $display = unserialize($ser_display);
    if (isset($ser_add)&&($ser_add!==''))
        $add = unserialize($ser_add);

    $i=0; $j=0;
    unset($delete_list);
    while ($i < $display->num_sites) {
        if ($display->site_list[$i]->name{0}=='#') {
            $delete_list[$j]=(int)$display->site_list[$i]->line_no;
            $j++;
        }
        $i++;
    }
    $num_delete_sites = $j;

    $i=0; $j=0;
    unset($add_list);
    while ($i < $add->num_sites) {
        if (($add->site_list[$i]->name!=';')&&($add->site_list[$i]->name{0}!='#')) {
            $add_list[$j]=$add->site_list[$i]->name; $j++; 
        }
        $i++;
    }
    $num_add_sites = $j;

    if (isset($add_list) || isset($delete_list)) {
        $file_to_read=fopen("..\\AllowedHostsKeywords.txt", 'r') 
        or die('Cannot read Exception free site config file');
        $i=0;
        while (!feof($file_to_read)) { $lines[$i]=fgets($file_to_read, MAXLINELEN); $i++; }
        @fclose($file_to_read);

        $file_to_write=fopen("..\\AllowedHostsKeywords.txt", 'w') 
        or die('Cannot write to Exception free site config file');

        // Write to file omitting the host keywords to be deleted
        $j=0; $k=0;
        if (isset($delete_list)) { 
            sort($delete_list); // fixed by dennis, 1st March 2005

            while (($k<$i) && ($j<$num_delete_sites)) {
                if ($k>$delete_list[$j])
                    $j++;
                else if ($k<$delete_list[$j]) {
                    fputs($file_to_write, $lines[$k]);
                    $k++;
                } else {
                    $j++;
                    $k++;
                }
            }
        }

        while ($k<$i) {
            fputs($file_to_write, $lines[$k]);
            $k++;
        }
        // Append the host keywords to be added at the end of the file
        $k=0; 
        if (isset($add_list)) {
            while ($k<$num_add_sites) { 
                fputs($file_to_write, "\r\n".$add_list[$k]); 
                $k++; 
            }
        }

        @fclose($file_to_write);
    }

    // unset all the session variables after saving 
    $ser_add=NULL;
    $ser_display=NULL;


    // AllowedHostsIPs.txt
    if (isset($ser_displayIP))
        $displayIP=unserialize($ser_displayIP);
    if (isset($ser_addIP))
        $addIP=unserialize($ser_addIP);

    $i=0; $j=0;
    unset($delete_listIP);
    while ($i < $displayIP->num_sites) {
        if ($displayIP->site_list[$i]->name{0}=='#') { 
            $delete_listIP[$j]=(int)$displayIP->site_list[$i]->line_no;
            $j++;
        }
        $i++;  
    }
    $num_delete_IPs=$j;

    $i=0; $j=0;
    unset($add_listIP);
    while ($i<$addIP->num_sites) {
        if (($addIP->site_list[$i]->name!=';')&&($addIP->site_list[$i]->name{0}!='#')) {
            $add_listIP[$j]=$addIP->site_list[$i]->name;
            $j++;
        }
        $i++;
    }
    $num_add_IPs = $j;

    unset($lines);
    if (isset($add_listIP)||isset($delete_listIP)) {
        $file_to_read=fopen("..\\AllowedHostsIPs.txt", 'r') or die('Cannot read Exception free IP config file');
        $i=0;
        while (!feof($file_to_read)) { $lines[$i] = fgets($file_to_read, MAXLINELEN); $i++; }
        @fclose($file_to_read);

        $file_to_write=fopen("..\\AllowedHostsIPs.txt", 'w')
        or die('Cannot write to Exception free IP config file');

        // Write to file omitting the host keywords to be deleted
        $j=0; $k=0;
        if (isset($delete_listIP)) {

            sort($delete_listIP); // fixed by dennis, 1st March 2005

            while (($k<$i) && ($j<$num_delete_IPs)) {
                if ($k>$delete_listIP[$j])
                    $j++;
                else if ($k<$delete_listIP[$j]) {
                    fputs($file_to_write, $lines[$k]); $k++;
                } else {
                    $j++;
                    $k++;
                }
            }
        }

        while ($k<$i) {
            fputs($file_to_write, $lines[$k]);
            $k++;
        }
        // Append the host IPs to be added at the end of the file
        $k=0;
        if (isset($add_listIP)) {
            while ($k<$num_add_IPs) {
                fputs($file_to_write, "\r\n".$add_listIP[$k]);
                $k++;
            }
        }

        @fclose($file_to_write);
    }

    // unset all the session variables after saving
    $ser_addIP=NULL;
    $ser_displayIP=NULL;


    //end port filtering
    $message='Exception free websites setting is successfully saved. All changes will take effect when you start FirstSpot next time.';
    $saved='true';
    $errorlog='';
}

else if(isset($removePeriod))
{
	$myobj = new COM("FSCONFIG.Cfgmgr") or die("addGroup.php FSCONFIG.Cfgmgr Object cannot be created!");
	$myobj->setKey($removePeriod, 'removePeriod', 'misc');
	$fs_path = $myobj->getFsPath();
	$cmd = "\"" . $fs_path . "dispatcher\\removeuser.exe\" " . $removePeriod;
	//$result = $myobj->runCommand($cmd);
	$sys = new sysfunc();
    $result = $sys->runCommand($cmd);
    $sys = null;
	//$myObj->Release();
	$myobj = null;
	
	if(strtolower($result)=="succeed")
		$message= "User(s) removed successfully!!";
	else
		$message= "Failed to remove user(s)!!";
	$saved='true';
	$errorlog='';
	
	$cat="u";
}
else if(isset($reset_bw))
{
    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('settingok.php FSCONFIG.Cfgmgr Object cannot be created!');
    // open dsn
    $dsn_file=$settingobj->getKey('Datasource', 'gateway');
    $dsn_source=fopen($dsn_file, 'r') or die('Cannot open DSN source file!');

    // prepare dsn string for ODBC connection
    $dsn='';

    if(!feof($dsn_source)) 
        $line=fgets($dsn_source,512);

    // read in each line
    while(!feof($dsn_source)) {
        $line=fgets($dsn_source,512);

        if(trim($line)!='') 
            $dsn=$dsn.$line;
    }

    // replace newline with semicolon
    $dsn=str_replace("\r\n",';',$dsn);

    // connect with ODBC
    $userDB=odbc_connect($dsn,'','');

    // connected
    if($userDB) {
	// 20080508 - Add total field
        // for firstspot user table, we reset all reserved fields
        $firstspotusertable=$settingobj->getKey('Datasource_Tablename', 'gateway');
        $query="UPDATE $firstspotusertable SET accumbw=null, accumbwUL=null, accumbwSha=null;";
        $result=odbc_exec($userDB,$query);

        // close the odbc connection
        odbc_close($userDB);

        // inform user
        $message='All users\' data transfer counters have been reset.';
        $saved='true';
        $errorlog='';
    } else {
        // warn user if connection failed
        $message='database connection failed!';
        $saved='false';
        $errorlog='database connection failed!';
    }

    //free COM object
    //$settingobj->Release();
    $settingobj=null;

    $cat='u';
}
else if(isset($exportUsageLog)&&($exportUsageLog==true))
{
    include_once("..\\authserv\\common_functions.php");
	
    $usr_usage_log="..\\log\\usrusagelog.csv";
    if (is_file($usr_usage_log) == TRUE)
        unlink($usr_usage_log);
    if (is_file($usr_usage_log) == FALSE) {
        touch ($usr_usage_log);
        $log_msg_heading="Name,IP/MAC,Login time,Logout time,Duration(min),Download Usage,Upload Usage,Total Usage\r\n";
        $fileHandler = fopen ($usr_usage_log, 'w');
        fwrite ($fileHandler, $log_msg_heading);
        fclose ($fileHandler);
    }

    $buff = file_get_contents($usr_usage_log);
    $fileHandler = fopen ($usr_usage_log, 'w');

    if (!flock ($fileHandler, LOCK_EX )) // exclusive lock
        $message.='Fail to lock the log file. ';

    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('settingok.php FSCONFIG.Cfgmgr Object cannot be created!');
    $firstspotuserlogtable=$settingobj->getKey('Datasource_Log_Tablename', 'gateway');

    //free COM object
    //$settingobj->Release();
    $settingobj=null;

    $query1= "SELECT name, logintime, logouttime, duration, ipormac, reserved10 as logints, reserved11 as logoutts, bwusage, bwusageul, bwusagesha
              FROM $firstspotuserlogtable ORDER BY reserved11";

    $result=db_query($query1);

    $log_msg_content = '';

    while(odbc_fetch_row($result)) {
        $name=odbc_result($result,'name');
        $logintime=odbc_result($result,'logintime');
        $logouttime=odbc_result($result,'logouttime');
        $duration=odbc_result($result,'duration');
        $macIP=odbc_result($result,'ipormac');
        $bwusage=odbc_result($result,'bwusage');
        $bwusageul=odbc_result($result,'bwusageul');
		$bwusagesha=odbc_result($result,'bwusagesha');

        // consider whether the long value of the result
        // is equal or larger than (2 to power 33)-1 
        if($macIP>=8589934890) {
            $macIP_str=make_mac_name($macIP);
        } else {
            $macIP_str=long2ip($macIP);

            // since the bytes of this ip is inverted, we need to reformat it
            $tok = strtok($macIP_str,'.');
            $i=0;
            $ip[$i++]=$tok;

            while($tok){
                $tok = strtok('.');
                $ip[$i++]=$tok;
            }

            if( $macIP_str == '255.255.255.255' || !(isset($ip[3])&&$ip[3]!=''&&$ip[3]!='0') )
                $macIP_str=make_mac_name($macIP);
            else
                $macIP_str="$ip[3].$ip[2].$ip[1].$ip[0]";
        }

        if(isset($duration)&&$duration)
            $duration=round($duration);

        $log_msg_content.="$name,$macIP_str,$logintime,$logouttime,$duration,";

        if($bwusage=='')
            $log_msg_content.='N/A,';
        else
            $log_msg_content.=round($bwusage).'KB,';        
		/* // spun: spun 20070312 - only display KB as the unit
		 else if($bwusage<1024)
			$log_msg_content.=$bwusage.'KB,';        
		else if($bwusage<1048576) {
            $bwusageMB = round($bwusage/1024,2);
            $log_msg_content.=$bwusageMB.'MB,';
        } else {
            $bwusageGB = round($bwusage/1024/1024,2);
            $log_msg_content.=$bwusageGB.'GB,';
        }
		*/

        // for upload
        if($bwusageul=='')
            $log_msg_content.="N/A,";
        else 
            $log_msg_content.=round($bwusageul)."KB,'";
		/* // spun: spun 20070312 - only display KB as the unit
	  else if($bwusageul<1024)
            $log_msg_content.=$bwusageul."KB\r\n";
        else if($bwusageul<1048576) {
            $bwusageulMB = round($bwusageul/1024,2);
            $log_msg_content.=$bwusageulMB."MB\r\n";
        } else {
            $bwusageulGB = round($bwusageul/1024/1024,2);
            $log_msg_content.=$bwusageulGB."GB\r\n";
        } */
		//for total
		if($bwusagesha=='')
            $log_msg_content.="N/A\r\n";
        else 
            $log_msg_content.=round($bwusagesha)."KB\r\n";
	}

    fwrite ($fileHandler, $buff.$log_msg_content);
    flock ($fileHandler, LOCK_UN ); // release the lock
    fclose ($fileHandler);

	if(isset($ClearLog)&&($ClearLog==true)){          
	$query2 = "DELETE FROM $firstspotuserlogtable ;" ;   //clear userlog table
	$result=db_query($query2);
	}
	
    $cat='u';
    $message='All user\'s usage log have been exported.';
    $saved='true';
    $errorlog='';
}

else if (isset($save_p)&&($save_p=='true')) 
{
    include_once("..\\authserv\\common_functions.php");
    $cat='p';
    if(isset($planname)) {
        $settingobj = new COM('FSCONFIG.Cfgmgr') or die('settingok.php FSCONFIG.Cfgmgr Object cannot be created!');
        $dsn_file=$settingobj->getKey('Datasource', 'gateway');
        $dsn_source=fopen($dsn_file, 'r') or die('Cannot open DSN source file!');     
        $dsn='';

        if (!feof($dsn_source)) 
            $line=fgets($dsn_source,512);

        while (!feof($dsn_source)) {
            $line=fgets($dsn_source,512);
            if (trim($line)!='') $dsn=$dsn.$line;
        }

        $dsn=str_replace("\r\n",';',$dsn);
        $planDB=odbc_connect($dsn,'','');

        if ($planDB) {
            // obtain low, medium or high BT value from config.ini
            $outval = $settingobj->getKey('bt_low', 'bw_throttle');
            if($outval!='') $low=$outval;

            $outval = $settingobj->getKey('bt_medium', 'bw_throttle');
            if($outval!='') $medium=$outval;
            $outval = $settingobj->getKey('bt_high', 'bw_throttle');
            if($outval!='') $high=$outval;

            $bt_ul_limit=null;
            $bt_dl_limit=null;

            if(!isset($plan_bt_mode))
                $plan_bt_mode=4;   // default is "use Global Setting"
            switch($plan_bt_mode)
            {
            case 0:
                $bt_ul_limit=0;
                $bt_dl_limit=0;
                break;
            case 1:
                $bt_ul_limit=$low;
                $bt_dl_limit=$low;
                break;
            case 2:
                $bt_ul_limit=$medium;
                $bt_dl_limit=$medium;
                break;
            case 3:
                $bt_ul_limit=$high;
                $bt_dl_limit=$high;
                break;
            case 4:
                $bt_ul_limit=null;
                $bt_dl_limit=null;
                break;
            case 5:  // treat as 0 (no throttling) if it is blank
                if (!isset($plan_bt_num) || $plan_bt_num=='')
                    $plan_bt_num=0;
                if (!isset($plan_bt_num_dl) || $plan_bt_num_dl=='')
                    $plan_bt_num_dl=0;
                $bt_ul_limit=$plan_bt_num;
                $bt_dl_limit=$plan_bt_num_dl;
                break;
            }

            $active_acc=0;
            $startDate=null;
            if(isset($bt_act_acc)) {
                switch($bt_act_acc)
                {
                case 0:
                    $active_acc=0;
                    break;  
                case 1:
                    $active_acc=1;      
                    break;
                case 2:
                    $active_acc=2;
                    if (isset($act_date))
                        $startDate=datetime_from_php($act_date, $act_time);
                    break;
                }
            }

            $status=0;
            if(isset($bt_plan_status))
            {
                switch($bt_plan_status)
                {
                case 0:
                    $status=0;
                    break;  
                case 1:
                    $status=1;
                    break;
                }
            }

            $timeleft=null;
            $logins=null;
            $endDate=null;
            $mins=null;

            if(!isset($cb_exp_acc0)) { //not never
                if(isset($cb_exp_acc1))  //timeleft
                {
                    $timeleft=$exp_timeleft;
                }
                if(isset($cb_exp_acc2)) //login
                {
                    $logins=$exp_login;
                }
                if(isset($cb_exp_acc3))  //date
                {
                    $endDate=datetime_from_php($exp_date, $exp_time);
                }
                if(isset($cb_exp_acc4)) {
                    if(strcmp($select_exp_timeleft,'min')==0)
                        $mins=$exp_days;
                    else if (strcmp($select_exp_timeleft,'hour')==0)
                        $mins=$exp_days*60;
                    else
                        $mins=$exp_days*60*24;
                }
            }

            $bwcount=null;
            $bwquota=null;
            $accumbw=null;
            if(isset($plan_bwcount)) {
                switch($plan_bwcount)
                {
                case -1:
                    $bwcount=null;
                    break;
                case 0:
                    $bwcount=0;
                    break;
                case 1:
					$bwcount=1;
                    $accumbw=0;
                    break;
                case 2:
                    $bwcount=2;
                    $bwquota=$plan_bwquota1;
                    $accumbw=0;
                    break;
                }
            }

            $bwcountUL=null;
            $bwquotaUL=null;
            $accumbwUL=null;
            if(isset($plan_bwcountUL)) {
                switch($plan_bwcountUL)
                {
                case -1:
                    $bwcountUL=null;
                    break;
                case 0:
                    $bwcountUL=0;
                    break;
                case 1:
                    $bwcountUL=1;
                    $accumbwUL=0;
                    break;
                case 2:
                    $bwcountUL=2;
                    $bwquotaUL=$plan_bwquota1UL;
                    $accumbwUL=0;
                    break;
                }
            }
			
			$bwcountSHA=null;
            $bwquotaSHA=null;
            $accumbwSHA=null;
            if(isset($plan_bwcountSHA)) {
                switch($plan_bwcountSHA)
                {
                case 0:
                    $bwcountSHA=0;
                    break;
                case 1:
                    $bwcountSHA=1;
                    $accumbwSHA=0;
                    break;
                case 2:
                    $bwcountSHA=2;
                    $bwquotaSHA=$plan_bwquota1SHA;
                    $accumbwSHA=0;
                    break;
                }
            }
			
            //plan recur_option
            if(isset($plans_recur_option) && $plans_recur_option == 1)
            {
                $week_sch = 0;
                if (isset($plans_cb_mon))
                    $week_sch += $plans_cb_mon;
                if (isset($plans_cb_tue))
                    $week_sch += $plans_cb_tue;
                if (isset($plans_cb_wed))
                    $week_sch += $plans_cb_wed;
                if (isset($plans_cb_thr))
                    $week_sch += $plans_cb_thr;
                if (isset($plans_cb_fri))
                    $week_sch += $plans_cb_fri;
                if (isset($plans_cb_sat))
                    $week_sch += $plans_cb_sat;
                if (isset($plans_cb_sun))
                    $week_sch += $plans_cb_sun;
                
                $plans_recur_sdate="";
                $plans_recur_edate="";
                if (isset($plans_recur_stime) && strlen($plans_recur_stime) > 0) {
                    $plans_recur_sdate = $plans_recur_stime;
                }

                if (isset($plans_recur_etime) && strlen($plans_recur_etime) > 0) {
                    $plans_recur_edate = $plans_recur_etime;
                }
            }
            //plan recur_option end

            $firstspotplantable=$settingobj->getKey('Datasource_Plans_Tablename', 'gateway');
            $query="SELECT * FROM $firstspotplantable WHERE pname='".$planname."';";
            $result=odbc_exec($planDB,$query);

            if (odbc_fetch_row($result)&&($addplan=='true')) {
                $message='Warning: The plan name chosen has been held. Please choose another one.';
                $saved='true';
                $errorlog='';
            } else {
                if(!isset($plan_usr_abw_rm))
                    $plan_usr_abw_rm = 3;

                switch($plan_usr_abw_rm)
                {
                case 0:
                    $plan_bwrmethod = 'disable';
                    $plan_bwrperiod = 'NULL';
                    $plan_bwrdate = 'NULL';
                    break;
                case 1:
                    if(!is_numeric($plan_usr_abw_rdate)||$plan_usr_abw_rdate<1||$plan_usr_abw_rdate>31)
                        $plan_usr_abw_rdate = 1;
                    if(!isset($plan_usr_abw_rp_1)||$plan_usr_abw_rp_1<1)
                        $plan_usr_abw_rp_1 = 1;

                    $plan_bwrmethod = 'month';
                    $plan_bwrdate = $plan_usr_abw_rdate;
                    $plan_bwrperiod = $plan_usr_abw_rp_1;
                    break;
                case 2:
                    if(!is_numeric($plan_usr_abw_rp_2)||$plan_usr_abw_rp_2<1)
                        $plan_usr_abw_rp_2 = 1;

                    $plan_bwrmethod = 'day';
                    $plan_bwrperiod = $plan_usr_abw_rp_2;
                    $todayTime = time(NULL);
                    $todayDate = getdate($todayTime);
                    $plan_bwrdate = $todayDate['mday'];
                    break;
                case 3:
                default:
                    $plan_bwrmethod = 'NULL';
                    $plan_bwrperiod = 'NULL';
                    $plan_bwrdate = 'NULL';
                    break;
                }

                $msg = '';
                if ($addplan=='true') {
                    $sql = "insert into " . $firstspotplantable; 
                    $sql .= " (pname, startmod, sdate, timeleft, logins, btul, btdl, eminutes, bwquota, edate, bwcount, status,
                        auto_del, bwrmethod, bwrperiod, bwrdate, bwcountUL, bwquotaUL, pagenum, acl, reqsignup, roption, rsdate, redate, weeksch, bwcountSHA, bwquotaSHA) VALUES ("; 
                    $sql .= "'" . $planname . "', ";
                    if(isset($active_acc))
                        $sql .= "". $active_acc . ", ";
                    else $sql .= "NULL, ";
                    if (strlen($startDate) > 0)
                        $sql .= "'" . $startDate . "', "; 
                    else
                        $sql .= "NULL, ";
                    if (strlen($timeleft) > 0)
                        $sql .= "" . $timeleft . ", "; 
                    else
                        $sql .= "NULL, ";
                    if (strlen($logins) > 0)
                        $sql .= "" . $logins . ", "; 
                    else
                        $sql .= "NULL, ";
                    if (strlen($bt_ul_limit) > 0)
                        $sql .= "" . $bt_ul_limit . ", "; 
                    else
                        $sql .= "NULL, ";
                    if (strlen($bt_dl_limit) > 0)
                        $sql .= "" . $bt_dl_limit . ", "; 
                    else
                        $sql .= "NULL, ";
                    if (strlen($mins) > 0)
                        $sql .= "" . $mins . ", "; 
                    else
                        $sql .= "NULL, ";
                    if (strlen($bwquota) > 0)
                        $sql .= "" . $bwquota . ", "; 
                    else
                        $sql .= "NULL, ";
                    if (strlen($endDate) > 0)
                        $sql .= "'" . $endDate . "', "; 
                    else
                        $sql .= "NULL, ";
					if (strlen($bwcount) > 0)
                        $sql .= "" . $bwcount . ", "; 
                    else
                        $sql .= "NULL, ";

                    if (strlen($status) > 0) 
                        $sql .= "" . $status . ", ";
                    else
                        $sql .= "NULL, ";
                    $sql .= "NULL, ";
                    if(strlen($plan_bwrmethod)>0&&$plan_bwrmethod!="NULL")
                        $sql.="'".$plan_bwrmethod."', ";
                    else
                        $sql.="NULL, ";
                    $sql.=$plan_bwrperiod.", ".$plan_bwrdate.", ";

                    if (strlen($bwcountUL) > 0)
                        $sql .= $bwcountUL.", ";
                    else
                        $sql .= "NULL, ";

                    if (strlen($bwquotaUL) > 0)
                        $sql .= "$bwquotaUL,";
                    else
                        $sql .= 'NULL,';

                    //print quota
                    if (isset($plan_printQuota)) {
                        if ($plan_printQuota)
                            $sql .= round($plan_printQuota).',';
                        else
                            $sql .= "NULL,";
                    } else {
                        $sql .= "NULL,";
                    }
                    //access control list
                    if (isset($plan_acl) && $plan_acl=='y') {
                        $sql .= "'Y',";
                    } else {
                        $sql .= 'NULL,';
                    }
                    //request signup
                    if (isset($plan_signup) && $plan_signup=='y') {
                        $sql .= "'Y'";
                    } else {
                        $sql .= 'NULL';
                    }					
                    
                    if(isset($plans_recur_option) && $plans_recur_option == 1)
                        $sql .= ", $plans_recur_option, '$plans_recur_sdate', '$plans_recur_edate', $week_sch";
                    else
                        $sql .= ", 0, NULL, NULL, 0";

					if (strlen($bwcountSHA) > 0)
                        $sql .= $bwcountSHA.", ";
                    else
                        $sql .= "NULL, ";

                    if (strlen($bwquotaSHA) > 0)
                        $sql .= "$bwquotaSHA,";
                    else
                        $sql .= 'NULL';	
						
                    $sql .= ");";
					
                } else if ($editplan=="true") {
                    $sql = "update " . $firstspotplantable . " set ";
                    if(isset($active_acc))
                        $sql .= "startmod=" . $active_acc . ", ";
                    else
                        $sql .= "startmod=NULL, ";

                    if (strlen($startDate) > 0)
                        $sql .= "sdate='" . $startDate . "', ";
                    else
                        $sql .= "sdate=NULL, ";

                    if (strlen($timeleft) > 0)
                        $sql .= "timeleft=" . $timeleft . ", ";
                    else
                        $sql .= "timeleft=NULL, ";

                    if (strlen($logins) > 0)
                        $sql .= "logins=" . $logins . ", ";
                    else
                        $sql .= "logins=NULL, ";

                    if (strlen($bt_ul_limit) > 0)
                        $sql .= "btul=" . $bt_ul_limit . ", ";
                    else
                        $sql .= "btul=NULL, ";

                    if (strlen($bt_dl_limit) > 0)
                        $sql .= "btdl=" . $bt_dl_limit . ", ";
                    else
                        $sql .= "btdl=NULL, ";

                    if (strlen($mins) > 0)
                        $sql .= "eminutes=" . $mins . ", ";
                    else
                        $sql .= "eminutes=NULL, ";

                    if (strlen($endDate) > 0)
                        $sql .= "edate='" . $endDate . "', ";
                    else
                        $sql .= "edate=NULL, ";
                    if (strlen($bwcount) > 0)
                        $sql .= "bwcount=" . $bwcount . ", ";
                    else
                        $sql .= "bwcount=NULL, ";
                    if (strlen($bwquota) > 0)
                        $sql .= "bwquota=" . $bwquota . ", ";
                    else
                        $sql .= "bwquota=NULL, ";

                    if (strlen($bwcountUL) > 0)
                        $sql .= "bwcountUL=" . $bwcountUL . ", ";
                    else
                        $sql .= "bwcountUL=NULL, ";

                    if (strlen($bwquotaUL) > 0)
                        $sql .= "bwquotaUL=" . $bwquotaUL . ", ";
                    else
                        $sql .= "bwquotaUL=NULL, ";
                    if (strlen($status) > 0)
                        $sql .= "status=" . $status . ", ";
                    else
                        $sql .= "status=NULL, ";

                    if(strlen($plan_bwrmethod)>0&&$plan_bwrmethod!="NULL")
                        $sql.="bwrmethod='".$plan_bwrmethod."', ";
                    else
                        $sql.="bwrmethod=NULL, ";

                    $sql.="bwrperiod=".$plan_bwrperiod.", bwrdate=".$plan_bwrdate.",";
                    //print quota
                    if (isset($plan_printQuota)) {
                        if ($plan_printQuota)
                            $plan_printQuota = round($plan_printQuota);
                        else
                            $plan_printQuota = 'NULL';
                        $sql .= "pagenum = $plan_printQuota,";
                    } else {
                        $sql .= 'pagenum = NULL,';
                    }
                    //access control list
                    if (isset($plan_acl) && $plan_acl=='y') {
                        $sql .= "acl = 'Y',";
                    } else {
                        $sql .= 'acl = NULL,';
                    }
                    //request signup
                    if (isset($plan_signup) && $plan_signup=='y') {
                        $sql .= "reqsignup = 'Y'";
                    } else {
                        $sql .= 'reqsignup = NULL';
                    }

                    if(isset($plans_recur_option) && $plans_recur_option == 1) {
                        $sql .= ", roption = $plans_recur_option";
                        $sql .= ", rsdate = '$plans_recur_sdate'";
                        $sql .= ", redate = '$plans_recur_edate'";
                        $sql .= ", weeksch = $week_sch";
                    } else {
                        $sql .= ", roption = 0";
                        $sql .= ", rsdate = NULL";
                        $sql .= ", redate = NULL";
                        $sql .= ", weeksch = 0";
                    }
					
					if (strlen($bwcountSHA) > 0)
                        $sql .= "bwcountSHA=" . $bwcountSHA . ", ";
                    else
                        $sql .= "bwcountSHA=NULL, ";

                    if (strlen($bwquotaSHA) > 0)
                        $sql .= "bwquotaSHA=" . $bwquotaSHA ;
                    else
                        $sql .= "bwquotaSHA=NULL ";

                    $sql .= " WHERE pname='".$planname."';";
                    $msg = " The current users under this plan will not be affected.";
                }
                $result=odbc_exec($planDB,$sql);
                odbc_close($planDB);
                $message='User plan information is successfully saved.'.$msg;
                $saved='true';
                $errorlog='';
            }
        }   //end planDB
        else {
            echo 'connection failed!';
        }
        //free COM object
        //$settingobj->Release();
        $settingobj=null;
    }   //end planname
}

else if(isset($listOfPlan))
{
    $cat='p';
    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('settingok.php FSCONFIG.Cfgmgr Object cannot be created!');

    // open dsn
    $dsn_file=$settingobj->getKey('Datasource', 'gateway');
    $dsn_source=fopen($dsn_file, 'r') or die('Cannot open DSN source file!');

    // prepare dsn string for ODBC connection
    $dsn='';

    if(!feof($dsn_source)) 
        $line=fgets($dsn_source,512);

    // read in each line
    while(!feof($dsn_source)) {
        $line=fgets($dsn_source,512);

        if(trim($line)!='') 
            $dsn=$dsn.$line;
    }

    // replace newline with semicolon
    $dsn=str_replace("\r\n",';',$dsn);

    // connect with ODBC
    $planDB=odbc_connect($dsn,'','');

    // connected
    if($planDB) {
        $firstspotplantable=$settingobj->getKey('Datasource_Plans_Tablename', 'gateway');
				
        $maxitem   = $settingobj->getKey('max_slot_open', 'cart');
				
        $deletedRecord = 0; 
				
        $aPlanToDelete = explode('|', $listOfPlan);
        foreach ($aPlanToDelete as $value) { 
	        	$tieditem = false;
	        	for ($i = 0; $i < $maxitem; $i++){
		        	$tempPlanName = $settingobj->getKey('plan'.$i, 'cart');
		        	if ($tempPlanName == $value ){
		        			$tieditem = true;
		        			break;		        	
	        		}
	        	}
	        	if ($tieditem  ==  false){
	            $query="DELETE FROM $firstspotplantable WHERE pname='".$value."';";
	            $result=odbc_exec($planDB,$query);
	            $deletedRecord++;
         	 }
        }

        // close the odbc connection
        odbc_close($planDB);
        
        $message = '';

        if ($deletedRecord != count($aPlanToDelete) ){
	        $message= count($aPlanToDelete) - $deletedRecord.' record(s) can not be deleted. <br>';
        }
                
	       if ($deletedRecord == 1)
	           $message.=$deletedRecord.' record is deleted.';
	       else if ($deletedRecord > 1)
	           $message.=$deletedRecord.' records are deleted.';
	       $saved='true';
	       $errorlog='';

    } else { 
        echo 'connection failed!';
    }
    //free COM object
    //$settingobj->Release();
    $settingobj=null;
}

//shopping cart
else if (isset($save_cart)&&($save_cart=='true'))
{
    $cat = 'cart';
    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('settingok.php FSCONFIG.Cfgmgr Object cannot be created!');

    $max_slot_open=$settingobj->getKey('max_slot_open', 'cart');
    $addErrorMsg = '';
    $addError = false;

    if (isset($redirect_cart))
        $rsult = $settingobj->setKey($redirect_cart, 'redirect_cart', 'gateway');

    // 20070924 - Set bandwidth reset counter flag
    if (isset($reset_bw_count_upon_purchase)) {
	$rsult = $settingobj->setKey($reset_bw_count_upon_purchase, 'reset_bw_count_upon_purchase', 'cart');
    }

    // 20071231 - Set data transfer quota action flag
    if (isset($add_replace_bw_quota)) {
	$rsult = $settingobj->setKey($add_replace_bw_quota, 'add_replace_bw_quota', 'cart');
    }

    // 20071231 - Set user suspend behavior flag
    if (isset($overwrite_user_suspend)) {
	$rsult = $settingobj->setKey($overwrite_user_suspend, 'overwrite_user_suspend', 'cart');
    }

    if(isset($mode)&&($mode=='add')) {
        $emptyspace = false;
        $addError = false;

        for ($i = 0; $i < $max_slot_open; $i++) {
            $old_description = $settingobj->getKey("description$i", 'cart');
            if ($old_description == $description) {

		// 20070712 - Correct typo and change color
                $addErrorMsg = '<font color="#FF0000">Error: Duplicated Description Cannot Be Added. Add Cancelled.</font>';

                $addError = true;
            }
        }

	// 20070712 - Check if selected plan is valid
	if ($addError == false && isset($plan)) {
	    $planTable = $settingobj->getKey('Datasource_Plans_Tablename', 'gateway');
	    $qStr = "SELECT * FROM ".$planTable." WHERE PNAME='".$plan."';";
	    $qResult = db_query($qStr);
	    $edate = odbc_result($qResult, 'EDATE');
	    $eminutes = odbc_result($qResult, 'EMINUTES');
	    if ((strlen($edate) > 0 || $edate != NULL) && (strlen($eminutes) > 0 || $eminutes != NULL)) {
		$addErrorMsg = '<font color="#FF0000">Error: '.$plan.' has more than one of the below fields set under "Conditions to suspend this account". Such plan is not allowed to be used in Shopping Cart.<br>- At a specific date and time<br>- After X minutes<br>Save aborted. Please modify the settings of the plan and try again.</font>';
		$addError = true;
	    }
	}

        if ($addError == false && isset($description)) {
            $rsult = $settingobj->setKey($max_slot_open + 1, 'max_slot_open', 'cart');

            $i = $max_slot_open;
            $rsult = $settingobj->setKey($description, "description$i", 'cart');

            if (isset($price))
                $rsult = $settingobj->setKey($price, "price$i", 'cart');

            if (isset($plan)) {
                if (strcmp($plan, '_plan_0') == 0)
                    $rsult = $settingobj->setKey('', "plan$i", 'cart');
                else
                    $rsult = $settingobj->setKey($plan, "plan$i", 'cart');
            }else
                $rsult = $settingobj->setKey('', "plan$i", 'cart');

            if (isset($recurring_enable)) {
                $rsult = $settingobj->setKey($recurring_enable, "recurring_enable$i", 'cart');
                if (isset($interval))
                    $rsult = $settingobj->setKey($interval, "interval$i", 'cart');
                if (isset($interval_unit))
                    $rsult = $settingobj->setKey($interval_unit, "interval_unit$i", 'cart');

                if ((isset($recurring_method)) && ($recurring_method == 'infinite')){
                    $rsult = $settingobj->setKey($recurring_method, "recurring_method$i", 'cart');
                    $rsult = $settingobj->setKey('', "fixed_number$i", 'cart');
                } else {
                    $rsult = $settingobj->setKey($recurring_method, "recurring_method$i", 'cart');
                    if (isset($fixed_number))
                        $rsult = $settingobj->setKey($fixed_number, "fixed_number$i", 'cart');
                }
            } else {
                $rsult = $settingobj->setKey('0', "recurring_enable$i", 'cart');
                $rsult = $settingobj->setKey('', "interval$i", 'cart');
                $rsult = $settingobj->setKey('', "interval_unit$i", 'cart');
                $rsult = $settingobj->setKey('', "recurring_method$i", 'cart');
                $rsult = $settingobj->setKey('', "fixed_number$i", 'cart');
            }

            if(isset($segment)) {
                $available_segments = '';
                for ($z = 0; $z < count($segment); ++$z) {
                    $available_segments .= $segment[$z] . ' ';
                }
                //echo $available_segments;exit();
                $rsult = $settingobj->setKey($available_segments, "segments$i", 'cart');
            } else
                $rsult = $settingobj->setKey('', "segments$i", 'cart');
        }
    }

    if (isset($mode)&&($mode=='edit')) {
        if (isset($existing_description)) {
            // get the description only
            $current_description =  explode(',', $existing_description);

	    // 20070712 - Check if selected plan is valid
	    if ($addError == false && isset($plan)) {
		$planTable = $settingobj->getKey('Datasource_Plans_Tablename', 'gateway');
		$qStr = "SELECT * FROM ".$planTable." WHERE PNAME='".$plan."';";
		$qResult = db_query($qStr);
		$edate = odbc_result($qResult, 'EDATE');
		$eminutes = odbc_result($qResult, 'EMINUTES');
		if ((strlen($edate) > 0 || $edate != NULL) && (strlen($eminutes) > 0 || $eminutes != NULL)) {
		    $addErrorMsg = '<font color="#FF0000">Error: '.$plan.' has more than one of the below fields set under "Conditions to suspend this account". Such plan is not allowed to be used in Shopping Cart.<br>- At a specific date and time<br>- After X minutes<br>Save aborted. Please modify the settings of the plan and try again.</font>';
		    $addError = true;
		}
	    }
	    if ($addError == false) {

		$i = 0;
		for ($i = 0; $i < $max_slot_open; $i++) {
		    $old_description=$settingobj->getKey("description$i", 'cart');
		    if (strcmp($old_description, $current_description[0]) != 0)
			continue;

		    if (isset($description))
			$rsult = $settingobj->setKey($description, "description$i", 'cart');
		    if (isset($price))
			$rsult = $settingobj->setKey($price, "price$i", 'cart');

		    if (isset($plan)) {
			if (strcmp($plan, '_plan_0') == 0)
			    $rsult = $settingobj->setKey('', "plan$i", 'cart');
			else
			    $rsult = $settingobj->setKey($plan, "plan$i", 'cart');
		    }else
			$rsult = $settingobj->setKey('', "plan$i", 'cart');

		    if (isset($recurring_enable)) {
			$rsult = $settingobj->setKey($recurring_enable, "recurring_enable$i", 'cart');
			if (isset($interval))
			    $rsult = $settingobj->setKey($interval, "interval$i", 'cart');
			if (isset($interval_unit))
			    $rsult = $settingobj->setKey($interval_unit, "interval_unit$i", 'cart');

			if ((isset($recurring_method)) && ($recurring_method == 'infinite')){
			    $rsult = $settingobj->setKey($recurring_method, "recurring_method$i", 'cart');
			    $rsult = $settingobj->setKey('', "fixed_number$i", 'cart');
			} else {
			    $rsult = $settingobj->setKey($recurring_method, "recurring_method$i", 'cart');
			    if (isset($fixed_number))
				$rsult = $settingobj->setKey($fixed_number, "fixed_number$i", 'cart');
			}
		    } else {
			$rsult = $settingobj->setKey('0', "recurring_enable$i", 'cart');
			$rsult = $settingobj->setKey('', "interval$i", 'cart');
			$rsult = $settingobj->setKey('', "interval_unit$i", 'cart');
			$rsult = $settingobj->setKey('', "recurring_method$i", 'cart');
			$rsult = $settingobj->setKey('', "fixed_number$i", 'cart');
		    }

		    if(isset($segment)) {
			$available_segments = '';
			for ($z = 0; $z < count($segment); ++$z) {
			    $available_segments .= $segment[$z] . ' ';
			}
			//echo $available_segments;exit();
			$rsult = $settingobj->setKey($available_segments, "segments$i", 'cart');
		    }
		    break;
		}
            }
        }
    }

    if (isset($mode)&&($mode=='del')) {

            $itemRecord = explode('*', $itemList);

            // since there is an extra '*' and make the itemRecord+1, the for loop need count($itemRecord)-1 
            for($z=0; $z < (count($itemRecord)-1); $z++) {
                // $itemPieces[0] : name (description)
                // $itemPieces[1] : price
                // $itemPieces[2] : plan
                // $itemPieces[3] : recurring_enable
                // $itemPieces[4] : interval
                // $itemPieces[5] : interval_unit
                // $itemPieces[6] : $recurring_method
                // $itemPieces[7] : $fixed_number
                // $itemPieces[8] : $avaliable_segment           
                $itemPieces = explode(',', $itemRecord[$z]);

                $description = $itemPieces[0];
                $price = $itemPieces[1];
                $recurring_enable = $itemPieces[3];
                $interval = $itemPieces[4];
                $interval_unit = $itemPieces[5];
                $recurring_method = $itemPieces[6];
                $fixed_number = $itemPieces[7];

                $i = 0;

                for ($i = 0; $i < $max_slot_open; $i++) {

                    $old_description=$settingobj->getKey("description$i", 'cart');
                    if ($old_description != $description)
                        continue;

                    $old_price=$settingobj->getKey("price$i", 'cart');
                    if ($old_price != $price)
                        continue;

                    $old_recurring_enable=$settingobj->getKey("recurring_enable$i", 'cart');
                    if ($old_recurring_enable != $recurring_enable)
                        continue;

                    $old_interval=$settingobj->getKey("interval$i", 'cart');
                    if ($old_interval!= $interval)
                        continue;

                    if ($recurring_enable == '1') {

                        $old_interval_unit=$settingobj->getKey("interval_unit$i", 'cart');

                        if ($old_interval_unit!= $interval_unit)
                            continue;

                        $old_recurring_method=$settingobj->getKey("recurring_method$i", 'cart');
                        if ($old_recurring_method != $recurring_method)
                            continue;
                    }

                    $old_fixed_number=$settingobj->getKey("fixed_number$i", 'cart');
                    if ($old_fixed_number!= $fixed_number)
                        continue;

                    $rsult = $settingobj->setKey('', "description$i", 'cart');
                    $rsult = $settingobj->setKey('', "price$i", 'cart');
                    $rsult = $settingobj->setKey('', "plan$i", 'cart');
                    $rsult = $settingobj->setKey('', "recurring_enable$i", 'cart');
                    $rsult = $settingobj->setKey('', "interval$i", 'cart');
                    $rsult = $settingobj->setKey('', "interval_unit$i", 'cart');
                    $rsult = $settingobj->setKey('', "recurring_method$i", 'cart');
                    $rsult = $settingobj->setKey('', "fixed_number$i", 'cart');
                    $rsult = $settingobj->setKey('', "segments$i", 'cart');
                } // end for

            } // end outter for
    }

    //free COM object
    //$settingobj->Release();
    $settingobj=null;

    if ($addError == true) {
        $message=$addErrorMsg;
        $saved='true';
        $errorlog='';
    } else {
        $message='Shopping Cart setting is successfully saved.';
        $saved='true';
        $errorlog='';
    }
}

else if(isset($save_key) && $save_key=='true') // instant key
{
    $cat = 'key';
    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('settingok.php FSCONFIG.Cfgmgr Object cannot be created!');

    // [sphl] 20070216 moved to save_key
    if(isset($dns_suffix))
        $rsult = $settingobj->setKey($dns_suffix, 'dns_suffix', 'gateway');
    
    if(isset($keyword_logout))
        $rsult = $settingobj->setKey($keyword_logout, 'this_logout', 'lang');

    if(isset($keyword_info))
        $rsult = $settingobj->setKey($keyword_info, 'this_info', 'lang');

    if(isset($keyword_cart))
        $rsult = $settingobj->setKey($keyword_cart, 'this_cart', 'lang');

    $addErrorMsg = '';
    $addError = false;

    if(isset($mode)&&($mode=='add')) {
        if(isset($keyword) && isset($url) && isset($last_key_num)) {
            for ($i=0 ;; $i++) {
                $saved_key[$i]=$settingobj->getKey("key_$i", 'lang');
                $saved_url[$i]=$settingobj->getKey("url_$i", 'lang');
                if($saved_key[$i]=='' || $saved_url[$i]=='')
                    break;
                else {
                    if($saved_url[$i]==$url || $saved_key[$i] == $keyword) {
                        $addErrorMsg = 'Duplicated with keyword '.$saved_key[$i].'. Instant Keyword is not saved!';
                        $addError = true;
                        break;
                    }
                }
            }
            if($addError == false) {
                $rsult = $settingobj->setKey($keyword, "key_$last_key_num", 'lang');
                $rsult = $settingobj->setKey($url, "url_$last_key_num", 'lang');
            }
        }
    }

    if (isset($mode)&&($mode=='edit')) {
        if(isset($keyword) && isset($url)) {
            for ($i=0 ;; $i++) {
                if(isset($key_index) && $i!=$key_index) { //skip to compare the rditing key itself
                    $saved_key[$i]=$settingobj->getKey("key_$i", 'lang');
                    $saved_url[$i]=$settingobj->getKey("url_$i", 'lang');
                    if($saved_key[$i]=='' || $saved_url[$i]=='')
                        break;
                    else {
                        if($saved_url[$i]==$url || $saved_key[$i] == $keyword) {
                            $addErrorMsg = 'Duplicated with keyword ' . $saved_key[$i] . '. Instant Keyword is not saved!';
                            $addError = true;
                            break;
                        }
                    }
                }   
            }
            if($addError == false  && isset($key_index) && $key_index>=0) {
                $rsult = $settingobj->setKey($keyword, "key_$key_index", 'lang');
                $rsult = $settingobj->setKey($url, "url_$key_index", 'lang');
            }
        }
    }

    if (isset($mode)&&($mode=='del')) {
        if(isset($last_key_num) && isset($key_index) && $key_index>=0) {
            $tokValue = 0;

            $tok = strtok($selected_item_list, ',');
            $y=0;

            while ($tok != '') { 

                for($x=0;$x<$last_key_num;$x++) 
                {
                    $key=$settingobj->getKey("key_$x", 'lang');

                    if($key == $tok)
                    {
                        for($y=$x;$y<$last_key_num;$y++) 
                        {
                            $tmp = $y+1;
                            $tmpkey=$settingobj->getKey("key_$tmp", 'lang');
                            $tmpurl=$settingobj->getKey("url_$tmp", 'lang');

                            $rsult = $settingobj->setKey($tmpkey, "key_$y", 'lang');
                            $rsult = $settingobj->setKey($tmpurl, "url_$y", 'lang');
                        }
                    }
                }
                $tok = strtok(',');
            }
        }   
    }
    //free COM object
    //$settingobj->Release();
    $settingobj=null;

    $message='Instant keyword setting is successfully saved. All changes will take effect when you start FirstSpot next time.' .$addErrorMsg;
    $saved='true';
    $errorlog='';
}

else if (isset($save_bcreate)&&($save_bcreate == 'true')) 
{
    $cat = 'bcreate';
    include_once("..\\authserv\\common_functions.php");

    $success_count = 0;
    $rounds = 0;
    $extra_msg = '';

    $bIsBulk = true; //create bulk accounts?
    $bIsPassRandom = true; //gen random password?
    $bIsPassSerial = false; //gen serial password? only for bulk mode
    $bIsPassFixed = false; //manually specifed password? not available in bulk mode

    $export_file = 'bulkuser.csv';

    $single_name = 'mary'; //for single user creation
    $fixed_pass = 'password'; //for single user creation, fixed password

    // init posted parms
    if (!isset($prefix))
        $prefix = '';
    $operator = $_SESSION["operator"];
    if ($operator == 'CafeOne') {
	$prefix = 'cafeone';
    } else if ($operator == 'CafeTwo') {
	$prefix = 'cafetwo';
    } 
    if (!isset($middle_digits_start) || ($middle_digits_start == ''))
        $middle_digits_start=1;
    if (!isset($middle_digits_end) || ($middle_digits_end == ''))
        $middle_digits_end=1;
    if (!isset($suffix) || ($suffix == ''))
        $suffix = '';
    if (!isset($plan) || ($plan == ''))
        $plan = '';
    if (!isset($password_length) || !is_numeric($password_length))
        $password_length = 10;
	
	if ( isset($slip_enable) &&  ($slip_enable=="on" ) )
		$slip_enable = true;
	else 	
		$slip_enable = false;
		
	if (!isset($users_per_page) || ($users_per_page == ''))
		$users_per_page = 5;		
		
	$settingobj = new COM("FSCONFIG.Cfgmgr") or die("editUser.php FSCONFIG.Cfgmgr Object cannot be created!");
	if ($slip_enable){	
		// slip format options	- from editUser.php /$printOption
		$settingobj->setKey(1, 'enable_slip_preview', 'bulk');
		$settingobj->setKey($users_per_page, 'slip_per_page', 'bulk');
		$settingobj->setKey($slip_format_option, 'slip_format_option', 'users');
		$slip_format = array();
		if ($slip_format_option == 1){ // 
			$settingobj->setKey($slip_title, 'past_slip_title', 'users');
			$settingobj->setKey($slip_title_size, 'past_slip_title_size', 'users');
			$settingobj->setKey($slip_end, 'past_slip_end', 'users');
			$settingobj->setKey($slip_end_size, 'past_slip_end_size', 'users');
			$slip_format['pTitle'] 		= $slip_title;
			$slip_format['pEnd'] 		= $slip_end;
			$slip_format['pTitleSize'] 	= 2*$slip_title_size;
			$slip_format['pEndSize'] 	= 2*$slip_end_size;
		}else{ // using default options
			$slip_format['pTitle'] 		= $settingobj->getKey('default_slip_title', 'users');
	        $slip_format['pTitleSize']	= 2*($settingobj->getKey('default_slip_title_size', 'users'));
	        $slip_format['pEnd'] = $settingobj->getKey('default_slip_end', 'users');
	        $slip_format['pEndSize']  = 2*($settingobj->getKey('default_slip_end_size', 'users'));
		}		
	} else {
		$settingobj->setKey(0, 'enable_slip_preview', 'bulk');
	}
	
	$settingobj=null;
    // end init

    // main
    $count = 1;
    $digits = $middle_digits_start;
    $output = '';
    $rounds = $middle_digits_end - $middle_digits_start + 1;
    if ($bIsBulk == false) { // for single user creation
        $rounds = 1;  //go only 1 round
        $prefix = $single_name; //make sure prefix is assigned with single_name
    }
    $base = floor(log($middle_digits_end)/log(10))+1 ;
    $dup_name = '';
	
	// 20070221 spun - begin printing user info in a slip 	
	$slip_users = array(); 		
	// 20070221 spun - end printing user info in a slip 	
	
    while ($count <= $rounds ) {
        if ($bIsBulk == true) 
            $username=$prefix.substr($digits+pow(10,$base),1).$suffix; //substr(x+1000,1) will have effect to add leading zeros
        else //single user
            $username = $prefix;
        if ($bIsPassFixed)
            $password = $fixed_pass;
        elseif ($bIsPassRandom)
            $password = fs_create_random_password($password_length);
        elseif ($bIsPassSerial)
            $password = substr($digits+pow(10,$base),1);
		
		$slip_user = array();		
        $result = fs_create_bulk_user($username, $password, $password, $plan, $slip_user);
        $digits = $digits + 1;
        if ($result == 0) { //successful - prepare username + password pair to screen				
			// 20070221 begin spun - printing user info in a slip 		
			if ($slip_enable){			
				$slip_users[$success_count] = $slip_user;
				$slip_users[$success_count]['username'] = $username;
				$slip_users[$success_count]['password'] = $password;			
			}
			// 20070221end spun - printing user info in a slip 			
			
            $success_count += 1;
            $output .= $username.','.$password."\r\n";
        } else
            $dup_name .= $username.'<br>';
			
		// 20070221 begin spun - printing user info in a slip 	
		unset($slip_user);
		
        $count = $count + 1;
    }

    if ($rounds != $success_count)
        $extra_msg = ' <br><font color="blue"><br><b>the difference is due to attempts in creating record(s) with the following <br>alreay-existed username(s):</b><br>'.$dup_name.'</font>';
    else
        $extra_msg = '';

    $backup = 0;
    while(is_writeable("..\\".$export_file)==true) { //file name exists
        $filename = substr($export_file, 0, strlen($export_file)-4);
        $extension = substr($export_file, strlen($export_file)-4, strlen($export_file)-1);

        $number = $backup;
        while (strlen($number) != 4)
            $number = '0' .$number;
        $backup_file = $filename . $number .$extension;
        while(is_writeable("..\\".$backup_file)==true) {
            $backup++;
            $number = $backup;
            while (strlen($number) != 4)
                $number = '0' .$number;
            $backup_file = $filename . $number . $extension;
        }
        rename("..\\".$export_file, "..\\".$backup_file);
    }

    //only write to file if there's at least one account created
    if ($success_count > 0) {
        if (is_file($export_file) == FALSE)
            touch ("..\\".$export_file);
        $fileHandler = fopen ("..\\".$export_file, 'w');
        fwrite ($fileHandler, $output);
        fclose ($fileHandler);
    }

    // end main
    $msg = "Number of accounts requested: $rounds<br>";
    $msg .= "Number of accounts created: $success_count<br>";
    $msg .= "$extra_msg<br>";
    $message = "$msg Bulk create account Action Completed.";
    $saved = 'true';
    $errorlog = '';
	
	if ( $slip_enable)	
			//include_once("slip.php");// 20070221 end spun - printing user info in a slip 	
	    if ($operator == 'CafeOne') {
		include_once("slipcafeone.php");
	    } else if ($operator == 'CafeTwo') {
		include_once("slipcafetwo.php");
	    } else {
		include_once("slip.php");
	    } 
}
// printing
else if (isset($save_print)&&($save_print=='true'))
{
    $cat = 'print';

    // get post data
    $print_support = (isset($_POST['print_support']))? $_POST['print_support'] : '0';
    $siteURL = (isset($_POST['siteURL']))? $_POST['siteURL'] : '';
    $security_mode = (isset($_POST['security_mode']))? $_POST['security_mode'] : 'cleartext';
    $siteUID = (isset($_POST['siteUID']))? $_POST['siteUID'] : '';
    $siteAuth = (isset($_POST['siteAuth']))? $_POST['siteAuth'] : '';
    $show_URL_login = (isset($_POST['show_login']))? $_POST['show_login']: '0';
    $show_URL_infobox = (isset($_POST['show_info']))? $_POST['show_info']: '0';

    // process data
    if ($print_support == '0') {
        $siteURL = '';
        $security_mode = 'cleartext';
    }
    if ($security_mode == 'cleartext') {
        $siteUID = '';
        $siteAuth = '';
    }
    
    // save the data
    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('settingok.php FSCONFIG.Cfgmgr Object cannot be created!');

    $rsult = $settingobj->setKey($print_support, 'PrintSupport', 'PrinterOn');
    $rsult = $settingobj->setKey($siteURL, 'SiteURL', 'PrinterOn');
    $rsult = $settingobj->setKey($siteUID, 'SiteUID', 'PrinterOn');
    $rsult = $settingobj->setKey($siteAuth, 'SiteAuth', 'PrinterOn');
    $rsult = $settingobj->setKey($show_URL_login, 'show_URL_login', 'PrinterOn');
    $rsult = $settingobj->setKey($show_URL_infobox, 'show_URL_infobox', 'PrinterOn');

    //free COM object
    //$settingobj->Release();
    $settingobj=null;

    $message = 'Print support settings are saved.';
    $saved = 'true';
    $errorlog = '';
}
// export print log
else if (isset($export_print_log) && ($export_print_log=='true'))
{
    include_once '../authserv/common_functions.php';

    $message = '';
    $print_log_file = '../log/print_log.csv';

    // removed the orginal log file first
    if (is_file($print_log_file)) {
        unlink($print_log_file);
    }

    touch($print_log_file);
    $log_msg_heading = "Logtime,RefId,Username,Status,Page,Format,DestId,InitId\r\n";
    $fileHandler = fopen($print_log_file, 'w');
    fwrite($fileHandler, $log_msg_heading);
    fclose($fileHandler);

    $buff = file_get_contents($print_log_file);
    $fileHandler = fopen ($print_log_file, 'w');

    if (!flock ($fileHandler, LOCK_EX )) // exclusive lock
        $message .= 'Fail to lock the log file.';

    $q = 'SELECT * from '.fs_printlog_table();

    $result = db_query($q);

    $log_msg_content = '';

    while (odbc_fetch_row($result)) {
        $logtime = odbc_result($result,'logtime');
        $refid = odbc_result($result,'refid');
        $username = odbc_result($result,'username');
        $status =odbc_result($result,'stat');
        $page = round(odbc_result($result,'page'));
        $format = odbc_result($result,'format');
        $destid = odbc_result($result,'destid');
        $initid = odbc_result($result,'intid');

        $log_msg_content .= "$logtime,$refid,$username,$status,$page,$format,$destid,$initid\r\n";
    }

    fwrite ($fileHandler, $buff.$log_msg_content);
    flock ($fileHandler, LOCK_UN ); // release the lock
    fclose ($fileHandler);

    $cat = 'print';
    $message .= '<br>All print log have been exported.';
    $saved = 'true';
    $errorlog = '';
}

else if (isset($exportImportDB)&&($exportImportDB=='true')) 
{
    $cat='u';
    include_once("..\\authserv\\common_functions.php");

    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('settingok.php FSCONFIG.Cfgmgr Object cannot be created!');
    $Datasource_Tablename=$settingobj->getKey('Datasource_Tablename', 'gateway');
    $Datasource_Plans_Tablename=$settingobj->getKey('Datasource_Plans_Tablename', 'gateway');
    $Datasource_PayPal_Table=$settingobj->getKey('Datasource_PayPal_Table', 'gateway');
    //$Datasource_Url_Tablename=$settingobj->getKey('Datasource_URL_Log_Tablename', 'gateway');
    
    //free COM object
    //$settingobj->Release();
    $settingobj=null;

    if (isset($table) && $table == 'user')
        $exportImportFile='userdata.csv';
    if (isset($table) && $table == 'plan')
        $exportImportFile='plandata.csv';
    if (isset($table) && $table == 'cc')
        $exportImportFile='ccdata.csv';
    /*if (isset($table) && $table == 'url')
        $exportImportFile='urldata.csv';*/

    if (isset($export)) {
        if (isset($table) && $table == 'user')
            $Datasource = $Datasource_Tablename;
        if (isset($table) && $table == 'plan')
            $Datasource = $Datasource_Plans_Tablename;
        if (isset($table) && $table == 'cc')
            $Datasource = $Datasource_PayPal_Table;
        /*if (isset($table) && $table == 'url')
            $Datasource = $Datasource_Url_Tablename;*/

        $msg = exportDB($exportImportFile, $table, $Datasource);
    } else if (isset($import)) {
        if (isset($table) && $table == 'user')
            $Datasource = $Datasource_Tablename;
        if (isset($table) && $table == 'plan')
            $Datasource = $Datasource_Plans_Tablename;
        if (isset($table) && $table == 'cc')
            $Datasource = $Datasource_PayPal_Table;
        /*if (isset($table) && $table == 'url')
            $Datasource = $Datasource_Url_Tablename;*/

        $msg = importDB($exportImportFile, $table, $Datasource);
				
				if (isset($table) && $table == 'user'){
	        // Check have any mac passive login user
	        $q = "SELECT count(*) as num FROM ".fs_usr_table()." WHERE MACasUsr='Y' and pwd is null";
  				$result = db_query($q);
  				$num = odbc_result($result, "num");
	        if ($num >0){
		        // Run QueryPassiveLogin after import user table and have mac passive login user
					  $settingobj = new COM('FSCONFIG.Cfgmgr') or die;
						$cmd = realpath("..\\");
						$cmd .= "\\dispatcher\\QueryPassiveLogin.exe";
						$settingobj->runCommand($cmd);
						//$settingobj->Release();
						$settingobj=null;
					}
				}
				
    } else if (isset($exportall)) {
        $table = 'user';
        $exportImportFile='userdata.csv';
        $Datasource = $Datasource_Tablename;
        $msg = exportDB($exportImportFile, $table, $Datasource);
        $table = 'plan';
        $exportImportFile='plandata.csv';
        $Datasource = $Datasource_Plans_Tablename;
        $msg .= '<br>'.exportDB($exportImportFile, $table, $Datasource);
        $table = 'cc';
        $exportImportFile='ccdata.csv';
        $Datasource = $Datasource_PayPal_Table;
        $msg .= '<br>'. exportDB($exportImportFile, $table, $Datasource);
        /*$table = 'url';
        $exportImportFile='urldata.csv';
        $Datasource = $Datasource_Url_Tablename;
        $msg = '<br>'. exportDB($exportImportFile, $table, $Datasource);*/
    } else if (isset($importall)) {
        $table = 'user';
        $exportImportFile='userdata.csv';
        $Datasource = $Datasource_Tablename;
        $msg = importDB($exportImportFile, $table, $Datasource);
        $table = 'plan';
        $exportImportFile='plandata.csv';
        $Datasource = $Datasource_Plans_Tablename;
        $msg .= '<br>'.importDB($exportImportFile, $table, $Datasource);
        $table = 'cc';
        $exportImportFile='ccdata.csv';
        $Datasource = $Datasource_PayPal_Table;
        $msg .= '<br>'. importDB($exportImportFile, $table, $Datasource);
        /*$table = 'url';
        $exportImportFile='urldata.csv';
        $Datasource = $Datasource_Url_Tablename;
        $msg = '<br>'. importDB($exportImportFile, $table, $Datasource);*/
				
				// Check have any mac passive login user	        
        $q = "SELECT count(*) as num FROM ".fs_usr_table()." WHERE MACasUsr='Y' and pwd is null";
  			$result = db_query($q);
  			$num = odbc_result($result, "num");
        if ($num >0){
	        // Run QueryPassiveLogin after import user table and have mac passive login user
				  $settingobj = new COM('FSCONFIG.Cfgmgr') or die;
					$cmd = realpath("..\\");
					$cmd .= "\\dispatcher\\QueryPassiveLogin.exe";
					$settingobj->runCommand($cmd);
					//$settingobj->Release();
					$settingobj=null;
				}

    }

    $message=$msg;
    $saved='true';
    $errorlog='';
}

else if(isset($status_forcelogout)) // disconnect
{
    $del = explode(',', $ForcelogoutString);

    // create COM object
    $myobj = new COM('FSAUTH.Authserv') or die('settingok.php FSAUTH.Authserv Object cannot be created!');

    $objrsult = $myobj->ForceLogout($ForcelogoutString);
    //$myObj->Release();
    $myobj=null;

    $cat = 'sstatus';
    $message = count($del).' user(s) are forced to logout';
    $saved = 'true';
    $errorlog= '';
}

else if (isset($save_acl) && $save_acl == 'true') {
    include_once('display_list.php');
    include_once('cmvar.php');
    $cat = 'acl';

    if (isset($ser_display_acl)&&($ser_display_acl!==''))
        $display_acl=unserialize($ser_display_acl);
    if (isset($ser_add_acl)&&($ser_add_acl!==''))
        $add_acl=unserialize($ser_add_acl);

    $str=''; $j=0; $n=0; $m=0;
    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('settingok.php FSCONFIG.Cfgmgr Object cannot be created!');
    $i=0;
    while ($i<$display_acl->num_sites && $n < 10) { //maximun number of ACL entries is 10
        //# and checked=true must both meet, or we ignore to delete it
        if ($display_acl->site_list[$i]->span{0}!='#'){
            $rsult = $settingobj->setKey($display_acl->site_list[$i]->span, "acl_addr$n", 'ACL');
            $n++;
        }
        $i++;
    }
    $j=$n;
    $i=0;
    while ($i<$add_acl->num_sites && ($m+$j) < 10) { //maximun number of ACL entries is 10
        $string2=$add_acl->site_list[$i]->span;
        if($add_acl->site_list[$i]->span{0}!='#') {
            $rsult = $settingobj->setKey($add_acl->site_list[$i]->span, 'acl_addr'.($m+$j), 'ACL');
            $m++;
        }
        $i++;
    }

    $num_acl=$m+$j;

    if(isset($num_acl)) {
        $rsult = $settingobj->setKey( $num_acl, 'num_acl', 'ACL');
    }

    //free COM object
    //$settingobj->Release();
    $settingobj=null;

    // unset all variables
    $ser_display_acl=NULL;
    $ser_add_acl=NULL;

    //Port filtering
    if (isset($ser_display_portflt)&&($ser_display_portflt!==''))
        $display_portflt = unserialize($ser_display_portflt);
    if (isset($ser_add_portflt)&&($ser_add_portflt!==''))
        $add_portflt = unserialize($ser_add_portflt);

    $str=''; $j=0; $n=0; $m=0;
    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('settingok.php FSCONFIG.Cfgmgr Object cannot be created!');
    $i=0;
    while ($i < $display_portflt->num_sites) {
        if($display_portflt->site_list[$i]->span{0}!='#'){
            $rsult = $settingobj->setKey($display_portflt->site_list[$i]->span, "flt_$n", 'Port Filter');
            $n++;
        }
        $i++;
    }

    $j=$n;
    $i=0;
    while ($i < $add_portflt->num_sites) {
        if($add_portflt->site_list[$i]->checked=='false' || $add_portflt->site_list[$i]->span{0}!='#') {
            if ($add_portflt->site_list[$i]->span{0}=='#') {
                $add_portflt->site_list[$i]->span = substr($add_portflt->site_list[$i]->span, 1, strlen($add_portflt->site_list[$i]->span));
            }
            $rsult = $settingobj->setKey($add_portflt->site_list[$i]->span, 'flt_'.($m+$j), 'Port Filter');
            $m++;
        }
        $i++;
    }

    $flt_num = $m+$j;
    $rsult = $settingobj->setKey($flt_num, 'flt_num', 'Port Filter');

    if (isset($portflt) && strcmp($portflt,'off')==0) {
        $num = $settingobj->getKey('flt_num', 'Port Filter');
        $rsult = $settingobj->setKey('0', 'flt_num', 'Port Filter');

        for ($i=0; $i < $num; $i++)
            $rsult = $settingobj->setKey('', "flt_$i", 'Port Filter');
    }

    //free COM object
    //$settingobj->Release();
    $settingobj=null;

    // unset all variables
    $ser_display_portflt=NULL;
    $ser_add_portflt=NULL;

    //****************************************************************************************************
    // URL tracking setting
    //****************************************************************************************************
    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('settingok.php FSCONFIG.Cfgmgr Object cannot be created!');

    if( isset($url_tracking) && $url_tracking == 0 )
        $settingobj->setKey('0', 'Trace_URL', 'gateway');
    else {
        $settingobj->setKey('1', 'Trace_URL', 'gateway');
        if(isset($url_interval) && $url_interval != '')
            $settingobj->setKey($url_interval, 'Trace_URL_Interval', 'gateway');
        else
            $settingobj->setKey('0', 'Trace_URL_Interval', 'gateway');
    }
    //$settingobj->Release();
    $settingobj=null;

    //****************************************************************************************************
    // End - URL tracking setting
    //****************************************************************************************************

    $message = get_cm_var('setcfg_acl_update_message');
    if ($num_acl==10) { //give warning that maximun number of ACL entries is 10
        $message .= ' '.get_cm_var('js_alert_acl_max');
    }
    $saved='true';
    $errorlog='';
}
// Failover
else if(isset($save_fo) && $save_fo=='true') 
{
    //Failover settings
    $cat='fo';
    
     $settingobj = new COM('FSCONFIG.Cfgmgr') or die('settingok.php FSCONFIG.Cfgmgr Object cannot be created!');
    	
	if ($fo_mode == 1 || $fo_mode == 2){
    	if ($fo_mode == 1){
		    if( $BackUpFSIP1>0 && $BackUpFSIP1<255 && $BackUpFSIP2>0 && $BackUpFSIP2<255 && $BackUpFSIP3>0 && $BackUpFSIP3<255 && $BackUpFSIP4>0 && $BackUpFSIP4<255 ){
			    $settingobj->setKey( $BackUpFSIP1.'.'.$BackUpFSIP2.'.'.$BackUpFSIP3.'.'.$BackUpFSIP4, 'BackUp_IP', 'FSFO' );
		    }
		    if( $BackUpFSNIC1>0 && $BackUpFSNIC1<255 && $BackUpFSNIC2>0 && $BackUpFSNIC2<255 && $BackUpFSNIC3>0 && $BackUpFSNIC3<255 && $BackUpFSNIC4>0 && $BackUpFSNIC4<255 ){
			    $settingobj->setKey( $BackUpFSNIC1.'.'.$BackUpFSNIC2.'.'.$BackUpFSNIC3.'.'.$BackUpFSNIC4, 'BackUp_NIC', 'FSFO' );
		    }
		    if( $BackUpFSDNS1>0 && $BackUpFSDNS1<255 && $BackUpFSDNS2>0 && $BackUpFSDNS2<255 && $BackUpFSDNS3>0 && $BackUpFSDNS3<255 && $BackUpFSDNS4>0 && $BackUpFSDNS4<255 ){
			    $settingobj->setKey( $BackUpFSDNS1.'.'.$BackUpFSDNS2.'.'.$BackUpFSDNS3.'.'.$BackUpFSDNS4, 'BackUp_DNS', 'FSFO' );
		    }
    	}else if ($fo_mode == 2){
		    if( $MainFSIP1>0 && $MainFSIP1<255 && $MainFSIP2>0 && $MainFSIP2<255 && $MainFSIP3>0 && $MainFSIP3<255 && $MainFSIP4>0 && $MainFSIP4<255 ){
			    $settingobj->setKey( $MainFSIP1.'.'.$MainFSIP2.'.'.$MainFSIP3.'.'.$MainFSIP4, 'Main_IP', 'FSFO' );
		    }
		    if( $MainFSNIC1>0 && $MainFSNIC1<255 && $MainFSNIC2>0 && $MainFSNIC2<255 && $MainFSNIC3>0 && $MainFSNIC3<255 && $MainFSNIC4>0 && $MainFSNIC4<255 ){
			    $settingobj->setKey( $MainFSNIC1.'.'.$MainFSNIC2.'.'.$MainFSNIC3.'.'.$MainFSNIC4, 'Main_NIC', 'FSFO' );
		    }
		    if( $MainFSDNS1>0 && $MainFSDNS1<255 && $MainFSDNS2>0 && $MainFSDNS2<255 && $MainFSDNS3>0 && $MainFSDNS3<255 && $MainFSDNS4>0 && $MainFSDNS4<255 ){
			    $settingobj->setKey( $MainFSDNS1.'.'.$MainFSDNS2.'.'.$MainFSDNS3.'.'.$MainFSDNS4, 'Main_DNS', 'FSFO' );
		    }
		    if ($fo_BackupMode == 0 || $fo_BackupMode ==1 || $fo_BackupMode ==2 || $fo_BackupMode == 3 ){
			  	$settingobj->setKey( $fo_BackupMode, 'BackupMode', 'FSFO' );
		    }
    	}
    	
    	if( ($port>=1024 && $port<=9999) || $port=='' )
		    $settingobj->setKey( $port, 'Port', 'FSFO' );
	
	   if( $interval>0 ){
		    $interval = $interval * 1000;
		    $settingobj->setKey( $interval, 'interval', 'FSFO' );
	    }else if ($interval==''){
		    $settingobj->setKey( $interval, 'interval', 'FSFO' );
	   	}
	}
	
    $settingobj->setKey( $fo_mode, 'mode', 'FSFO' );
    $settingobj=null;
}

?>
<html>
<head></head>
<!-- redirect back to setcfg.php -->
<body onLoad="window.location.href='setcfg.php?category=<?= $cat ?>'">
</body>
</html>
